#------------------------------------------------------------------------------
# CUMULVS AUTOCONF MACROS DIR:
# See if the user gave us the location of the CUMULVS autoconf macro directory
# one must be present and contain the correct files, or else the user
# must give the directory that contains the correct files.
#------------------------------------------------------------------------------
# 
#places to look for the autoconf-macros dir
AC_DEFUN(STV_FIND_AUTOCONF_MACROS_DIR,
[
stv_autoconf_macro_dirs="
    $STV_ROOT/autoconf-macros
    $prefix/CUMULVS/autoconf-macros
    /usr/local/CUMULVS/autoconf-macros
    $CURRDIR_PARENT/autoconf-macros
    $CURRDIR_PARENT/CUMULVS/autoconf-macros
    $CURRDIR_GRANDPARENT/CUMULVS/autoconf-macros
    $CURRDIR_GRANDPARENT/autoconf-macros
    $CURRDIR_GREATGRANDPARENT/CUMULVS/autoconf-macros
    $CURRDIR_GREATGRANDPARENT/autoconf-macros
    $CURRDIR_GREATGRANDPARENT/../autoconf-macros
    $CURRDIR_ANCESTOR/autoconf-macros
    $HOME/projects/CUMULVS/autoconf-macros
"

AC_ARG_WITH(stv_autoconf_macros_dir, 
    [Location of cumulvs autoconf macros directory:
  --with-stv_autoconf_macros_dir=STV_AUTOCONF_MACROS_DIR
                          The location of CUMULVS autoconf macros directory. 
                          Give the full path:
                              --with-stv_autoconf_macros_dir=/usr/local/CUMULVS/autoconf-macros
                          ] ,
    , [with_stv_autoconf_macros_dir=no])

case "$with_stv_autoconf_macros_dir" in
    no)
        # lUser input error
        with_stv_autoconf_macros_dir=_searching
        ;;
    yes)
        #  User didn't give the option or didn't give useful
        #  information, search for it ourselves
        with_stv_autoconf_macros_dir=_searching
        ;;
    *)
        STV_AUTOCONF_MACROS_DIR="$with_stv_autoconf_macros_dir"
        ;;
esac

if test "$with_stv_autoconf_macros_dir" = _searching ; then
    AC_MSG_CHECKING([for REQUIRED cumulvs autoconf macro directory])
    AC_MSG_RESULT([])
    stv_autoconf_macros_dir_found=0
    for chome in $stv_autoconf_macro_dirs ; do
        if test -d $chome ; then
	    AC_MSG_CHECKING([for stvmain.m4 in $chome])
	    if test ! -f "$chome/stvmain.m4" ; then
    		AC_MSG_RESULT([no])
	    else
		AC_MSG_RESULT([yes])
		stv_autoconf_macros_dir_found=1
		with_stv_autoconf_macros_dir=$chome
            fi

	    if test "$stv_autoconf_macros_dir_found" = 1; then
	        break
	    fi
        fi
    done
fi
if test "$with_stv_autoconf_macros_dir" = _searching ; then
    AC_MSG_RESULT([Cannot find CUMULVS autoconf macro directory.])
    AC_MSG_ERROR([Please reinstall the CUMULVS rpm or source and/or use --with-stv_autoconf_macros_dir=STV_ROOT/autocon-macros.])
    with_stv_autoconf_macros_dir=stv_macro_dir_not_found
fi

STV_AUTOCONF_MACROS_DIR="$with_stv_autoconf_macros_dir"
AC_SUBST(STV_AUTOCONF_MACROS_DIR)

]
)

#----------------------------------------------------------------------------
# END: STV FIND AUTOCONF MACROS DIR M4
#----------------------------------------------------------------------------
