
#------------------------------------------------------------------------------
# STV_OS_NAME, STV_OS_VERSION, STV_OS_RELEASE: See if the user gave us the OS info
# if not check for our selfs.
#------------------------------------------------------------------------------
# 
#places to look for os version
AC_DEFUN(STV_FIND_OS_RELEASE,
[
stv_os_release_dirs="
    /etc
"
with_stv_os_name=
with_stv_os_version=

AC_ARG_WITH(stv_os_release,
    [Release of your OS, e.g. rh9, mdk9.1:
  --with-stv_os_release=STV_OS_RELEASE
                          The full release name of your os. 
                          Give full release like rh8.1, mdk9.1 ...:
                              --with-stv_os_release=mdk9.1
                          ] ,
    , [with_stv_os_release=no])

case "$with_stv_os_release" in
    no)
        # lUser input error
        with_stv_os_release=_searching
        ;;
    yes)
        #  User didn't give the option or didn't give useful
        #  information, search for it ourselves
        with_stv_os_release=_searching
        ;;
    *)
        ;;
esac


if test "$with_stv_os_release" = _searching ; then
    AC_MSG_CHECKING([for OPTIONAL OS name])
    AC_MSG_RESULT([])
    stv_os_name_found=0
    for chome in $stv_os_release_dirs ; do
        if test -d $chome ; then
	    AC_MSG_CHECKING([for redhat-release in $chome])
	    if test ! -f "$chome/redhat-release" ; then
    		AC_MSG_RESULT([no])
	    else
		AC_MSG_RESULT([yes])
		stv_os_name_found=1
		with_stv_os_name=processing
            fi

	    if test "$stv_os_name_found" = 1; then
	        break
	    fi
        fi
    done
fi

if test "$stv_os_name_found" = 1; then
	dollar1="$""1"
	dollar2="$""2"
	dollar4="$""4"
	dollar5="$""5"
	with_stv_os_name=`awk "{printf $dollar1}" < $chome/redhat-release`
	AC_MSG_CHECKING([for OS name])
	if test "$with_stv_os_name" = Mandrake; then
	    AC_MSG_RESULT([$with_stv_os_name Linux found!])
	    AC_MSG_CHECKING([for OS version number])
	    with_stv_os_version=`awk "{printf $dollar4}" < $chome/redhat-release`
	    AC_MSG_RESULT([$with_stv_os_version])
	    with_stv_os_name=mdk
	else
	    if test "$with_stv_os_name" = Red; then
		with_stv_os_name=`awk "{printf $dollar1 $dollar2}" < $chome/redhat-release`
		AC_MSG_RESULT([$with_stv_os_name Linux found!])
		AC_MSG_CHECKING([for OS version number])
	    	with_stv_os_version=`awk "{printf $dollar5}" < $chome/redhat-release`
	    	AC_MSG_RESULT([$with_stv_os_version])
		with_stv_os_name=rh
	    else
		AC_MSG_RESULT([no known OS name and version found!])
		AC_MSG_RESULT([RPM build not supported!])
		AC_MSG_RESULT([OR Use --with-stv_os_full_release=YOUR_OS_FULL_RELASE (e.g. mdk9.1).])
		$with_stv_os_version=0
	    fi
	fi
else
	AC_MSG_RESULT([Cannot find OS name.])
	AC_MSG_RESULT([OR Use --with-stv_os_full_release=YOUR_OS_FULL_RELASE (e.g. mdk9.1).])
	with_stv_os_name=NON
	with_stv_os_version=NON
	with_stv_os_release=_searching
fi

if test "$with_stv_os_release" = _searching; then
	with_stv_os_release=$with_stv_os_name$with_stv_os_version
fi

AC_MSG_RESULT([OS release is: $with_stv_os_release])

STV_OS_NAME="$with_stv_os_name"
STV_OS_VERSION="$with_stv_os_version"
STV_OS_RELEASE="$with_stv_os_release"
AC_SUBST(STV_OS_NAME)
AC_SUBST(STV_OS_VERSION)
AC_SUBST(STV_OS_RELEASE)

]
)

#----------------------------------------------------------------------------
# END: STV OS RELEASE M4
#----------------------------------------------------------------------------
