#------------------------------------------------------------------------------
#  Find CUMULVS RPM root directory (non blocking check)
#------------------------------------------------------------------------------
AC_DEFUN(STV_FIND_RPM_ROOT_DIR_NB,
[

with_rpm_inst_found=0

#  CUMULVS_RPM search paths
stv_rpm_cumulvs_dirs_nb="
    $prefix/CUMULVS
    /usr/local/CUMULVS
    $HOME/projects/CUMULVS
    $CURRDIR_PARENT/CUMULVS
    $CURRDIR_GRANDPARENT/CUMULVS
    $CURRDIR_GREATGRANDPARENT/CUMULVS
    $CURRDIR_GREATGRANDPARENT/../CUMULVS
    $CURRDIR_ANCESTOR/CUMULVS
    $STV_ROOT
"

AC_ARG_WITH(cumulvs_rpm, 
    [Location of CUMULVS_RPM:
  --with-cumulvs_rpm=CUMULVS_RPM_TREE
                          The location of CUMULVS rpm directory
                          Give the full path: e.g.
                              --with-cumulvs_rpm=/usr/local/CUMULVS ] ,
    , [with_cumulvs_rpm=yes])

case "$with_cumulvs_rpm" in
    no)
        # lUser input error
        with_cumulvs_rpm=_searching
        ;;
    yes)
        #  User didn't give the option or didn't give useful
        #  information, search for it ourselves
        with_cumulvs_rpm=_searching
        ;;
    *)
	with_make_install=install
	with_rpm_inst_found=1
	with_autoconf_macro_dir=$with_cumulvs_rpm/autoconf-macros
        ;;
esac

if test "$with_cumulvs_rpm" = _searching ; then
    AC_MSG_CHECKING([for CUMULVS rpm install directory])
    AC_MSG_RESULT([])
    stv_rpm_cumulvs_dir_found=0
    for chome in $stv_rpm_cumulvs_dirs_nb ; do
        if test -d $chome ; then
	    AC_MSG_CHECKING([for stvconfig in $chome])
	    if test ! -f "$chome/stvconfig"  ; then
		AC_MSG_RESULT([no])
	    else
		AC_MSG_RESULT([yes.])
		stv_rpm_cumulvs_dir_found=1
		with_cumulvs_rpm=$chome
		with_make_install=install
		with_rpm_inst_found=1
		with_autoconf_macro_dir=$chome/autoconf-macros
	    fi

	    if test "$stv_rpm_cumulvs_dir_found" = 1; then
	        break
	    fi
        fi
    done
fi

if test ! -z "$STV_SOURCE_DIST_FOUND"; then
#echo "STV_SOURCE_DIST_FOUND is not ZERO"
    if test "$STV_SOURCE_DIST_FOUND" = 0; then
	AC_MSG_CHECKING([for CUMULVS STV_ROOT environment variable])
	if test ! "$STV_ROOT" = "$with_cumulvs_rpm"; then
    	    if test ! "$STV_ROOT" = ""; then	
		AC_MSG_RESULT([found. Is set to $STV_ROOT. It is different from the source directory.])
		AC_MSG_RESULT([Please reset STV_ROOT to $with_cumulvs_rpm.])
		with_rpm_inst_found=0
    	    else
		AC_MSG_RESULT([ok])
    	    fi
	else
    	    AC_MSG_RESULT([ok])
	fi
    fi
else
    AC_MSG_CHECKING([for CUMULVS STV_ROOT environment variable])
    if test ! "$STV_ROOT" = "$with_cumulvs_rpm"; then
        if test ! "$STV_ROOT" = ""; then
	    AC_MSG_RESULT([found. Is set to $STV_ROOT. It is different from the RPM install directory.])
	    AC_MSG_RESULT([Please reset STV_ROOT to $with_cumulvs_rpm.])
	    with_rpm_inst_found=0
    	else
	    AC_MSG_RESULT([ok])
    	fi
    else
        AC_MSG_RESULT([ok])
    fi
fi

if test "$with_cumulvs_rpm" = _searching ; then
    AC_MSG_RESULT([Cannot find CUMULVS RPM installation.])
    AC_MSG_RESULT([Please do a 'make install' for the CUMULVS source distribution or])
    AC_MSG_RESULT([install a correct CUMULVS binary rpm distribution and/or])
    AC_MSG_RESULT([use --with-cumulvs_rpm=STV_ROOT.])
    with_make_install=no_install
    with_rpm_inst_found=0
    with_autoconf_macro_dir=no_autoconf_macros_install_dir_found
else
    if test ! -f "$with_cumulvs_rpm/stvconfig"  ; then
    	AC_MSG_RESULT([No stvconfig in $with_cumulvs_rpm.])
    	AC_MSG_RESULT([Please do a 'make install' for the CUMULVS source distribution or])
    	AC_MSG_RESULT([install a correct CUMULVS binary rpm distribution and/or use --with-cumulvs_rpm=STV_ROOT.])
	with_make_install=no_install
	with_rpm_inst_found=0
	with_autoconf_macro_dir=no_autoconf_macros_install_dir_found
    fi
fi

if test ! -z "$STV_SOURCE_DIST_FOUND"; then
#echo "STV_SOURCE_DIST_FOUND is not ZERO"
    if test "$STV_SOURCE_DIST_FOUND" = "0"; then
	echo "STV_SOURCE_DIST_FOUND is 0"
        if test "$with_rpm_inst_found" = 1; then
	    STV_ROOT="$with_cumulvs_rpm"
            AC_SUBST(STV_ROOT)
	fi
    fi
else
    if test "$with_rpm_inst_found" = 1; then
    	STV_ROOT="$with_cumulvs_rpm"
    	AC_SUBST(STV_ROOT)
    fi
fi

if test "$with_rpm_inst_found" = 1; then
    with_stv_rpm_inst_dir="$with_cumulvs_rpm"
else
    with_stv_rpm_inst_dir=
fi

STV_AUTOCONF_MACROS_DIR="$with_autoconf_macro_dir"
STV_RPM_DIST_FOUND="$with_rpm_inst_found"
STV_MAKE_INST="$with_make_install"
STV_RPM_ROOT="$with_stv_rpm_inst_dir"
AC_SUBST(STV_AUTOCONF_MACROS_DIR)
AC_SUBST(STV_RPM_DIST_FOUND)
AC_SUBST(STV_MAKE_INST)
AC_SUBST(STV_RPM_ROOT)
]
)

#---------------------------------------------------------------------------
# END: STV FIND RPM ROOT DIR NB M4 AUTOCONF MACRO
#---------------------------------------------------------------------------