
########################################################################
# Find Tcl/Tk
# (stolen from ical-2.2 configure.in, (c) 1993 by Sanjay Ghemawat)
# (hacked a little :-)
#
#-----------------------------------------------------------------------
# TCLTK_ROOT: See if the user gave us the location of tcltk
# then search $stv_inst_tcltk_dirs.
# One of these directories must be
# present and contain the correct files, or else the user
# must give the directory that contains the correct files.
#-----------------------------------------------------------------------
AC_DEFUN(STV_LIB_TCLTK,
[

AC_MSG_CHECKING([for OPTIONAL Tcl/Tk installation])
AC_MSG_RESULT([])

legal_tk_versions="8.3 8.0 4.9 4.8 4.7 4.6 4.5 4.4 4.3 4.2 4.1"
legal_tcl_versions="8.3 8.0 7.9 7.8 7.7 7.6 7.5"

user_tcltk="no"

valid_tcltk="yes"

STV_TCLTK_MAKE_TARGET=""
STV_TCLTK_MAKE_SHARED_TARGET=""	

#### Check for User Installation - via TCL_LIBRARY, TK_LIBRARY env vars
if test -n "$TCL_LIBRARY" -a -n "$TK_LIBRARY"; then

	#### Find tclConfig.sh
	AC_MSG_CHECKING(TCL_LIBRARY environment variable)
	if test -f $TCL_LIBRARY/../tclConfig.sh; then
		tclconfig=`dirname $TCL_LIBRARY`
	elif test -f $TCL_LIBRARY/../unix/tclConfig.sh; then
		tclconfig="`dirname $TCL_LIBRARY`/unix"
	elif test -f $TCL_LIBRARY/../unix/$arch/tclConfig.sh; then
		tclconfig="`dirname $TCL_LIBRARY`/unix/$arch"
	fi

	if test -n "$tclconfig"; then

		AC_MSG_RESULT(tclConfig.sh found)

		#### Find tkConfig.sh
		AC_MSG_CHECKING(TK_LIBRARY environment variable)
		if test -f $TK_LIBRARY/../tkConfig.sh; then
			tkconfig=`dirname $TK_LIBRARY`
		elif test -f $TK_LIBRARY/../unix/tkConfig.sh; then
			tkconfig="`dirname $TK_LIBRARY`/unix"
		elif test -f $TK_LIBRARY/../unix/$arch/tkConfig.sh; then
			tkconfig="`dirname $TK_LIBRARY`/unix/$arch"
		fi

		if test -n "$tkconfig"; then
			AC_MSG_RESULT(tkConfig.sh found)
			user_tcltk="yes"
		else
			AC_MSG_RESULT(tkConfig.sh not found)
		fi

	else
		AC_MSG_RESULT(tclConfig.sh not found)
	fi
fi

#### Couldn't Find User's Tcl/Tk, Use Sanjay's Stuff...
if test "$user_tcltk" = "no" -a "$valid_tcltk" = "yes"; then
echo "checking user install"

stv_tclConfig_dirs="
	/usr/lib
	/usr/local/lib
	/usr/local/bin
"

	#### Find tclsh
	AC_ARG_WITH(tclsh,
		[  --with-tclsh=<path>     full path name of tclsh],
		tclsh="$withval")
	if test -n "$tclsh"; then
	    AC_MSG_CHECKING(for tclsh)
	    AC_MSG_RESULT($tclsh)
	else
	   	tclsh_list="tclsh"
	   	for v in $legal_tcl_versions; do
			tclsh_list="$tclsh_list tclsh$v"
	   	done
	   	# Look for tclsh variants in $prefix/bin, and then in $PATH.
	   	AC_PATH_PROGS(tclsh,$tclsh_list)
	fi
	if test -z "$tclsh"; then
	    AC_MSG_RESULT([

	Could not find tclsh in your search PATH.
	
	If you need the CUMULVS Tcl/Tk examples,
	please supply the location of a tclsh executable
	by running configure with the following option
		--with-tclsh=<full path name of tclsh>
		])
		valid_tcltk="no"
	fi
	
	#### Continue searching...
	if test "$valid_tcltk" = "yes"; then

	#### Run tclsh to find tclConfig.sh
	AC_MSG_CHECKING([for tclConfig.sh])
	AC_MSG_RESULT([])
	AC_ARG_WITH(tclconfig,
	[  --with-tclconfig=<path> directory that contains tclConfig.sh],
	tclconfig="$withval")
	if test -z "$tclconfig"; then
	    changequote(,)
	    tclconfig=`echo 'puts stdout [file dirname [info library]]' \
			| $tclsh`
	    changequote([,])
	fi

	AC_MSG_CHECKING([in $tclconfig])
	if test ! -f "$tclconfig/tclConfig.sh"; then
	    AC_MSG_RESULT([no.])
	    stv_tclConfig_dir_found=0
	    for chome in $stv_tclConfig_dirs ; do
		AC_MSG_CHECKING([in $chome])
	        if test ! -f "$chome/tclConfig.sh"; then
		    AC_MSG_RESULT([no.])
		else
		    AC_MSG_RESULT([yes.])
		    stv_tclConfig_dir_found=1
		    tclconfig=$chome
	    	fi

	    	if test "$stv_tclConfig_dir_found" = 1; then
	            break
	    	fi
	    done	
	else
	    stv_tclConfig_dir_found=1
	fi

	if test "$stv_tclConfig_dir_found" = 0; then
	    AC_MSG_RESULT([

		Could not find tclConfig.sh.

		If you need the CUMULVS Tcl/Tk examples,
		please specify the directory that contains tclConfig.sh
		by running configure with the following option
			--with-tclconfig=<path to directory containing tclConfig.sh>
	
		Warning: Only Tcl versions 7.5 and later provide a tclConfig.sh
		file - make sure you have a new enough version installed on your
		system.
		])
	    valid_tcltk="no"
	else
	    AC_MSG_RESULT([using tclConfig.sh in $tclconfig])
	fi

	#### Continue searching...
	if test "$valid_tcltk" = "yes"; then

	#### Look for tkConfig.sh (in same directory as tclConfig.sh?)
	AC_MSG_CHECKING(for tkConfig.sh)
	AC_ARG_WITH(tkconfig,
	[  --with-tkconfig=<path>  directory that contains tkConfig.sh],
	tkconfig="$withval")
	if test -z "$tkconfig"; then
	    tkconfig="$tclconfig"
	fi
	if test ! -f "$tkconfig/tkConfig.sh"; then
	    AC_MSG_RESULT([

	Could not find tkConfig.sh.

	If you need the CUMULVS Tcl/Tk examples,
	please specify the directory that contains tkConfig.sh
	by running configure with the following option
		--with-tkconfig=<path name of directory containing tkConfig.sh>
	
	Warning: Only Tk versions 4.1 and later provide a tkConfig.sh file.
	Make sure you have a new enough version installed on your system.
		])
		valid_tcltk="no"
	else
		AC_MSG_RESULT($tkconfig/tkConfig.sh)
	fi

	fi	# valid_tcltk #2

	fi	# valid_tcltk #1

fi

#### If Tcl/Tk Supposedly Found, Proceed With Testing...
if test "$valid_tcltk" = "yes"; then

	#### Verify/Load the Tcl/Tk configuration files 
	AC_MSG_CHECKING($tclconfig/tclConfig.sh)
	if test -f "$tclconfig/tclConfig.sh"; then
		AC_MSG_RESULT(ok)
		. $tclconfig/tclConfig.sh
		AC_MSG_CHECKING($tkconfig/tkConfig.sh)
		if test -f "$tkconfig/tkConfig.sh"; then
			AC_MSG_RESULT(ok)
			. $tkconfig/tkConfig.sh
		else
	    	AC_MSG_RESULT([

	Could not find tkConfig.sh.

	If you need the CUMULVS Tcl/Tk examples,
	please specify the directory that contains tkConfig.sh
	by running configure with the following option
		--with-tkconfig=<path name of directory containing tkConfig.sh>
	
	Warning: Only Tk versions 4.1 and later provide a tkConfig.sh file.
	Make sure you have a new enough version installed on your system.
			])
			valid_tcltk="no"
		fi
	else
	    AC_MSG_RESULT([

	Could not find tclConfig.sh.

	If you need the CUMULVS Tcl/Tk examples,
	please specify the directory that contains tclConfig.sh
	by running configure with the following option
		--with-tclconfig=<path to directory containing tclConfig.sh>
	
	Warning: Only Tcl versions 7.5 and later provide a tclConfig.sh
	file - make sure you have a new enough version installed on your
	system.
		])
		valid_tcltk="no"
	fi

	#### Spank Tcl/Tk Prefix If User Installation
	if test "$user_tcltk" = "yes"; then

	  if test "$valid_tcltk" = "yes"; then
		AC_MSG_CHECKING(for Tcl lib directory)
		if test -f "$tclconfig/$TCL_LIB_FILE"; then
			TCL_LIB_DIR="$tclconfig"
		elif test -f "$tclconfig/$arch/$TCL_LIB_FILE"; then
			TCL_LIB_DIR="$tclconfig/$arch"
		else
			for lib in $tclconfig/*/$TCL_LIB_FILE; do
				nm $lib 1>/dev/null 2>&1
				if test "$?" = "0"; then
					TCL_LIB_DIR=`dirname $lib`
					break
				fi
			done
			# try goofy SUN4 library name...
			alt_lib_file=`echo $TCL_LIB_FILE | sed 's/\.//'`
			for lib in $tclconfig/*/$alt_lib_file; do
				nm $lib 1>/dev/null 2>&1
				if test "$?" = "0"; then
					TCL_LIB_DIR=`dirname $lib`
					TCL_LIB_FILE="$alt_lib_file"
					TCL_VERSION=`echo $TCL_VERSION | sed 's/\.//'`
					break
				fi
			done
		fi
		TCL_LIB_SPEC=""
		if test -n "$TCL_LIB_DIR"; then
			AC_MSG_RESULT($TCL_LIB_DIR)
		else
			AC_MSG_RESULT(Not Found)
			valid_tcltk="no"
		fi
	  fi

	  if test "$valid_tcltk" = "yes"; then
		AC_MSG_CHECKING(for matching tcl.h)
		tmp=`dirname $tclconfig`
		if test -f "$tmp/generic/tcl.h"; then
			tclhdir="$tmp/generic"
			AC_MSG_RESULT($tclhdir/tcl.h)
		else
			tmp=`dirname $tmp`
			if test -f "$tmp/generic/tcl.h"; then
				tclhdir="$tmp/generic"
				AC_MSG_RESULT($tclhdir/tcl.h)
			else
				AC_MSG_RESULT(Not Found)
				valid_tcltk="no"
			fi
		fi
	  fi

	  if test "$valid_tcltk" = "yes"; then
		AC_MSG_CHECKING(for Tk lib directory)
		if test -f "$tkconfig/$TK_LIB_FILE"; then
			TK_LIB_DIR="$tkconfig"
		elif test -f "$tkconfig/$arch/$TK_LIB_FILE"; then
			TK_LIB_DIR="$tkconfig/$arch"
		else
			for lib in $tkconfig/*/$TK_LIB_FILE; do
				nm $lib 1>/dev/null 2>&1
				if test "$?" = "0"; then
					TK_LIB_DIR=`dirname $lib`
					break
				fi
			done
			# try goofy SUN4 library name...
			alt_lib_file=`echo $TK_LIB_FILE | sed 's/\.//'`
			for lib in $tkconfig/*/$alt_lib_file; do
				nm $lib 1>/dev/null 2>&1
				if test "$?" = "0"; then
					TK_LIB_DIR=`dirname $lib`
					TK_LIB_FILE="$alt_lib_file"
					TK_VERSION=`echo $TK_VERSION | sed 's/\.//'`
					break
				fi
			done
		fi
		TK_LIB_SPEC=""
		if test -n "$TK_LIB_DIR"; then
			AC_MSG_RESULT($TK_LIB_DIR)
		else
			AC_MSG_RESULT(Not Found)
			valid_tcltk="no"
		fi
	  fi

	  if test "$valid_tcltk" = "yes"; then
		AC_MSG_CHECKING(for matching tk.h)
		tmp=`dirname $tkconfig`
		if test -f "$tmp/generic/tk.h"; then
			tkhdir="$tmp/generic"
			AC_MSG_RESULT($tkhdir/tk.h)
		else
			tmp=`dirname $tmp`
			if test -f "$tmp/generic/tk.h"; then
				tkhdir="$tmp/generic"
				AC_MSG_RESULT($tkhdir/tk.h)
			else
				AC_MSG_RESULT(Not Found)
				valid_tcltk="no"
			fi
		fi
	  fi

	else
		if test -z "$TCL_EXEC_PREFIX"; then
			TCL_EXEC_PREFIX="$TCL_PREFIX"; fi
		if test -z "$TK_EXEC_PREFIX"; then
			TK_EXEC_PREFIX="$TK_PREFIX"; fi
		TCL_LIB_DIR="${TCL_EXEC_PREFIX}/lib"
		TK_LIB_DIR="${TK_EXEC_PREFIX}/lib"
	fi

	if test "$valid_tcltk" = "yes"; then
		#### Check that the library files exist
		AC_MSG_CHECKING(for installed Tcl/Tk library files)
		lib1=`eval "echo ${TCL_LIB_DIR}/${TCL_LIB_FILE}"`
		lib2=`eval "echo ${TK_LIB_DIR}/${TK_LIB_FILE}"`
		for f in "$lib1" "$lib2"; do
    		if test ! -f "$f"; then
				AC_MSG_RESULT($f not found)
				valid_tcltk="no"
    		fi
		done
		AC_MSG_RESULT(ok)
	fi

	if test "$valid_tcltk" = "yes"; then

	#### Find the flags for linking with the Tcl/Tk libraries
	if test "$TCL_LIB_VERSIONS_OK" = "ok"; then
		TCL_LIB_VERSIONS_OK=yes
	fi
	if test "$TCL_LIB_VERSIONS_OK" = "1"; then
		TCL_LIB_VERSIONS_OK=yes
	fi

	if test -z "$TCL_LIB_SPEC"; then
    	if test "$TCL_LIB_VERSIONS_OK" = "yes"; then
        	TCL_LIB_SPEC="-L${TCL_LIB_DIR} -ltcl${TCL_VERSION}"
    	else
        	TCL_LIB_SPEC=`eval "echo ${TCL_LIB_DIR}/${TCL_LIB_FILE}"`
    	fi
	fi

	if test -z "$TK_LIB_SPEC"; then
    	if test "$TCL_LIB_VERSIONS_OK" = "yes"; then
        	TK_LIB_SPEC="-L${TK_LIB_DIR} -ltk${TK_VERSION}"
    	else
        	TK_LIB_SPEC=`eval "echo ${TK_LIB_DIR}/${TK_LIB_FILE}"`
    	fi
	fi

	#### Check Tcl/Tk versions

	AC_REQUIRE_CPP()

	AC_MSG_CHECKING(for up-to-date Tcl version in tcl.h)
	AC_ARG_WITH(tclhdir,
	[  --with-tclhdir=<path>   directory that contains tcl.h],
		tclhdir="$withval")
	if test -z "$tclhdir"; then
    	# Search for tcl.h
    	tclhdir="${TCL_PREFIX}/include"
    	for dir in "${TCL_PREFIX}/include" \
				/usr/include /usr/include/tcl; do
			if test -f "$dir/tcl.h"; then
	    		tclhdir="$dir"
	    		break
			fi
    	done
	fi

	# Find tk.h
	AC_ARG_WITH(tkhdir,
	[  --with-tkhdir=<path>    directory that contains tk.h],
		tkhdir="$withval")
	if test -z "$tkhdir"; then
    	# Search for tk.h
    	tkhdir="$tclhdir"
    	for dir in "${TK_PREFIX}/include" \
				/usr/include /usr/include/tcl; do
			if test -f "$dir/tk.h"; then
	    		tkhdir="$dir"
	    		break
			fi
    	done
	fi

	AC_EGREP_CPP(good_tcl_version,
	[#include "$tclhdir/tcl.h"
	#if ((TCL_MAJOR_VERSION == $TCL_MAJOR_VERSION) && (TCL_MINOR_VERSION == $TCL_MINOR_VERSION))
    	good_tcl_version
	#endif],is_good_tcl_version=yes,is_good_tcl_version=no)
	AC_MSG_RESULT($is_good_tcl_version)
	if test "$is_good_tcl_version" = "no"; then
		AC_MSG_RESULT([
		If you need the CUMULVS Tcl/Tk examples, then please make sure
		you have the latest Tcl version installed on your system.])
		STV_TCLTK_MAKE_TARGET=""
		STV_TCLTK_MAKE_SHARED_TARGET=""	
	else
		AC_MSG_CHECKING(for up-to-date Tk version in tk.h)
		AC_EGREP_CPP(good_tk_version,
		[#include "$tclhdir/tcl.h"
		#include "$tkhdir/tk.h"
		#if ((TK_MAJOR_VERSION == $TK_MAJOR_VERSION) && (TK_MINOR_VERSION == $TK_MINOR_VERSION))
	    	good_tk_version
		#endif],is_good_tk_version=yes,is_good_tk_version=no)
		AC_MSG_RESULT($is_good_tk_version)
		if test "$is_good_tk_version" = "no"; then
			AC_MSG_RESULT([If you need the CUMULVS TCL/TK examples,
			Make sure you have a new enough TK version installed on your system.])
			valid_tcltk="no"
		else
			STV_TCLTK_MAKE_TARGET="f_all sl_all"
			STV_TCLTK_MAKE_SHARED_TARGET="sh_f_all sh_sl_all"
		fi
	fi

	TCL_INCDIR="$tclhdir"
	TK_INCDIR="$tkhdir"

	fi    # valid_tcltk = yes

#	if test "$valid_tcltk" = "yes"; then
		# Pass through any special X libraries / directories...
#		AC_MSG_CHECKING(for hard-wired X11 library directory)
#		if test "$x_libraries" != "NONE"; then
#			X_LIBS="-L$x_libraries"
#			AC_MSG_RESULT($x_libraries)
#		else
#			X_LIBS=""
#			AC_MSG_RESULT(no)
#		fi
#	fi

	if test "$valid_tcltk" = "no"; then
		AC_MSG_RESULT([
	Some component of Tcl/Tk was not found on your system.

	If you need the CUMULVS TCL/TK examples,
	please make sure Tcl/Tk are installed correctly on your
	system and then rerun configure.
		])
	fi

fi


#### Export variables discovered during Tcl/Tk configuration

AC_SUBST(TCL_LIB_SPEC)
AC_SUBST(TCL_PREFIX)
AC_SUBST(TCL_EXEC_PREFIX)
AC_SUBST(TCL_LIBS)
AC_SUBST(TK_LIB_SPEC)
AC_SUBST(TK_LIBS)
#AC_SUBST(X_LIBS)
AC_SUBST(TK_PREFIX)
AC_SUBST(TK_EXEC_PREFIX)
AC_SUBST(TK_XINCLUDES)
AC_SUBST(TCL_INCDIR)
AC_SUBST(TK_INCDIR)
AC_SUBST(STV_TCLTK_MAKE_TARGET)
AC_SUBST(STV_TCLTK_MAKE_SHARED_TARGET)
]
)
#----------------------------------------------------------------------------
# END: STV TCLTK MACRO M4
#----------------------------------------------------------------------------
