
#------------------------------------------------------------------------------
# STV_AVS_PATH: See if the user gave us the location of AVS5
# then search $stv_inst_avs_dirs.
# One of these directories must be
# present and contain the correct files, or else the user
# must give the directory that contains the correct files.
#------------------------------------------------------------------------------
AC_DEFUN(STV_PROG_AVS,
[
stv_inst_avs_dirs="
    /usr/local/avs
    /usr/avs
    $CURRDIR_GRANDPARENT/avs
    $CURRDIR_GREATGRANDPARENT/avs
    $HOME/avs
"

STV_AVS_PATH=""
STV_AVS_INST=""
STV_AVS_MAKE_TARGET=""
STV_AVS_MAKE_SHARD_TARGET=""
STV_AVS_CLEAN=""

AC_ARG_WITH(avs,
    [Location of AVS: 
  --with-avs=STV_AVS_PATH   
                          The location of AVS
                          Give the full path: e.g.
                          --with-avs=/usr/local/avs ] ,
    , [with_avs=yes])

case "$with_avs" in
    no)
        # lUser input error
        with_avs=_searching
        ;;
    yes)
        #  User didn't give the option or didn't give useful
        #  information, search for it ourselves
        with_avs=_searching
        ;;
    *)
        STV_AVS_PATH="$with_avs"
        ;;
esac

AC_MSG_CHECKING([for OPTIONAL AVS5])
AC_MSG_RESULT([])

if test "$with_avs" = _searching ; then
    stv_prog_avs_found=0
    for chome in $stv_inst_avs_dirs ; do
        if test -d $chome ; then
	    AC_MSG_CHECKING([for include/avs/avs.h in $chome])
	    if test -f "$chome/include/avs/avs.h"  ; then
        	AC_MSG_RESULT([yes])
		stv_prog_avs_found=1
	    else
		AC_MSG_RESULT([no])
	    fi

	fi

	if test "$stv_prog_avs_found" = 1; then
            with_avs=$chome
            break
        fi
    done
fi

if test "$with_avs" = _searching ; then
    AC_MSG_RESULT([Cannot find AVS5 root directory.])
    AC_MSG_RESULT([If you have it, please use --with-avs=AVS_PATH.])
    with_avs="AVS_installation_not_found"
    STV_AVS_MAKE_TARGET=""
    STV_AVS_MAKE_SHARD_TARGET=""
    STV_AVS_INST=""
    STV_AVS_CLEAN=""
fi
if test ! "$with_avs" = _searching ; then
    if test ! -f "$with_avs/include/avs/avs.h"  ; then
        AC_MSG_RESULT([No include/avs/avs.h in $with_avs.])
        AC_MSG_RESULT([ERROR: Please install AVS5 visualization environment.])
	with_avs="AVS_installation_not_found"
	STV_AVS_MAKE_TARGET=""
	STV_AVS_MAKE_SHARD_TARGET=""
	STV_AVS_INST=""
	STV_AVS_CLEAN=""
    else
	STV_AVS_MAKE_TARGET="a_all"
	STV_AVS_MAKE_SHARD_TARGET="sh_a_all"
	STV_AVS_INST="a_install"
	STV_AVS_CLEAN="yes"
    fi
else
    with_avs=AVS_installation_not_found
fi


STV_AVS_PATH="$with_avs"
AC_SUBST(STV_AVS_PATH)
AC_SUBST(STV_AVS_MAKE_TARGET)
AC_SUBST(STV_AVS_MAKE_SHARD_TARGET)
AC_SUBST(STV_AVS_INST)
AC_SUBST(STV_AVS_CLEAN)
]
)
#---------------------------------------------------------------------------
# END: STV AVS MACRO M4
#---------------------------------------------------------------------------
