
#------------------------------------------------------------------------------
# STV_CPP_PATH: See if the user gave us the full path to cpp
# one must be present and contain the correct files, or else the user
# must give the directory that contains the correct files.
#------------------------------------------------------------------------------
# 
#places to look for cpp
AC_DEFUN(STV_PROG_CPP,
[
stv_prog_cpp_dirs="
    /usr/lib
    /usr/bin
"

AC_ARG_WITH(stv_cpp_path,
    [Location of cpp:
  --with-stv_cpp_path=STV_CPP_PATH
                          The location cpp. 
                          Give the full path:
                              --with-stv_cpp_path=/usr/bin
                          ] ,
    , [with_stv_cpp_path=no])

case "$with_stv_cpp_path" in
    no)
        # lUser input error
        with_stv_cpp_path=_searching
        ;;
    yes)
        #  User didn't give the option or didn't give useful
        #  information, search for it ourselves
        with_stv_cpp_path=_searching
        ;;
    *)
        STV_CPP_PATH="$with_stv_cpp_path"
        ;;
esac

if test "$with_stv_cpp_path" = _searching ; then
    AC_MSG_CHECKING([for OPTIONAL program cpp])
    AC_MSG_RESULT([])
    stv_cpp_path_found=0
    for chome in $stv_prog_cpp_dirs ; do
        if test -d $chome ; then
	    AC_MSG_CHECKING([for cpp in $chome])
	    if test ! -f "$chome/cpp" ; then
    		AC_MSG_RESULT([no])
	    else
		AC_MSG_RESULT([yes])
		stv_cpp_path_found=1
		with_stv_cpp_path=$chome/cpp
            fi

	    if test "$stv_cpp_path_found" = 1; then
	        break
	    fi
        fi
    done
fi
if test "$with_stv_cpp_path" = _searching ; then
    AC_MSG_RESULT([Cannot find program cpp.])
    AC_MSG_RESULT([If needed installed use --with-stv_cpp_path=/usr/bin.])
    with_stv_cpp_path=PROGRAM_CPP_NOT_FOUND
fi

STV_CPP_PATH="$with_stv_cpp_path"
AC_SUBST(STV_CPP_PATH)

]
)

#----------------------------------------------------------------------------
# END: STV PROG CPP M4
#----------------------------------------------------------------------------
