
#------------------------------------------------------------------------------
# STV_MP_SELECT: See if the user gave us the prefered Cumulvs mp library
# selectable: pvm(default), mpi
#------------------------------------------------------------------------------
AC_DEFUN(STV_SELECT_CUMULVS_MP,
[
AC_ARG_WITH(cumulvs_mp_lib,
    [What message passing library to use (PVM , MPI):
  --with-cumulvs-mp-lib=MessagePassingLibrary
                          What message passing library to use
                          Give the full name (supported PVM):
                              --with-cumulvs-mp-lib=PVM ],
    , [with_cumulvs_mp_lib=yes])


AC_MSG_CHECKING([for CUMULVS Message Passing Library])
case "$with_cumulvs_mp_lib" in
    no)
        #  User specified --without-mp-system
        #  print a warning.
        AC_MSG_WARN([Option '--without-cumulvs-mp-lib' not allowed.])
        AC_MSG_ERROR([A message library is required for CUMULVS.])
        ;;
    yes)
        #  User didn't give the option or didn't give useful
        #  information, search for it ourselves
	AC_MSG_RESULT([not selected, using default PVM library])
        STV_MP="PVM"
        ;;
    *)
	if test $with_cumulvs_mp_lib = "MPI"; then
	    AC_MSG_RESULT([$with_cumulvs_mp_lib not supported, selecting PVM])
	    with_cumulvs_mp_lib=PVM
	else
 	    if test $with_cumulvs_mp_lib = "PVM"; then
	    	AC_MSG_RESULT([$with_cumulvs_mp_lib selected])
	    else
	    	AC_MSG_ERROR([$with_cumulvs_mp_lib not supported. Please use PVM or MPI!])
	    fi
	fi

        STV_MP="$with_cumulvs_mp_lib"
        ;;
esac

AC_SUBST(STV_MP)
]
)

#------------------------------------------------------------------------------
# END: STV MP SELECT MACRO M4 library MACRO M4
#------------------------------------------------------------------------------

