
/* mod_gen Version 1                                                     */
/* Module Name: "ReadArrays" (Input) (Subroutine)                        */
/* Author: Raymond E. Flanery, Jr.                                       */
/* Date Created: Fri Nov  9 12:49:17 2001                                */
/*                                                                       */
/* This file is automatically generated by the Module Generator (mod_gen)*/
/* Please do not modify or move the contents of this comment block as    */
/* mod_gen needs it in order to read module sources back in.             */
/*                                                                       */
/* output 0 "output" user_data tri_user_data	 "triangleData.h"         */
/* End of Module Description Comments                                    */

#include <stdio.h>
#include <avs/avs.h>
#include <avs/port.h>
#include "triangleData.h"
 
/* ----> START OF USER-SUPPLIED CODE SECTION #1 (INCLUDE FILES, GLOBAL VARIABLES)*/
/* <---- END OF USER-SUPPLIED CODE SECTION #1                            */
 
/* *****************************************/
/*  Module Description                     */
/* *****************************************/
int ReadArrays_desc()
{

	extern int ReadArrays_compute();
	int in_port, param, iresult;

	AVSset_module_name("ReadArrays", MODULE_DATA);

	/* Output Port Specifications              */
	AVScreate_output_port("output", "struct  tri_user_data");

	AVSset_compute_proc(ReadArrays_compute);
        AVSload_user_data_types("../avs/triangleData.h");
/* ----> START OF USER-SUPPLIED CODE SECTION #2 (ADDITIONAL SPECIFICATION INFO)*/
/* <---- END OF USER-SUPPLIED CODE SECTION #2                            */
	return(1);
}
 
/* *****************************************/
/* Module Compute Routine                  */
/* *****************************************/
int ReadArrays_compute( output)
	tri_user_data	 **output;
{

        int nvert, ntri, i1, i2, i3,i;
        float x, y, z;
        char d1[256], d2[256];
	int iresult;
        FILE *fin;

/* ----> START OF USER-SUPPLIED CODE SECTION #3 (COMPUTE ROUTINE BODY)   */

        *output = (tri_user_data *)AVSdata_alloc("struct tri_user_data",0);
           
        fin = fopen("tri.dat","r");
        fscanf(fin,"%s",d1);
        while ( strcmp(d1,"POINTS") != 0)
          fscanf(fin,"%s",d1);
        fscanf(fin,"%d %s\n",&nvert,d1);
        if (nvert > 1000){
          printf("You need to set 1000 to at least %d in triangleData.h\n",nvert);
          exit(1);
        }
        (*output)->nvert = nvert;
        for (i=0; i<nvert; i++){
          fscanf(fin,"%f %f %f",&x, &y, &z);
          (*output)->vertices[i][0] = x;
          (*output)->vertices[i][1] = y;
          (*output)->vertices[i][2] = z;
        }
        fscanf(fin,"%s",d1);
        while ( strcmp(d1,"CELLS") != 0)
          fscanf(fin,"%s",d1);
        fscanf(fin,"%d %d",&ntri,&i1);
        if (ntri > 1000){
          printf("You need to set 1000 to at least %d in triangleData.h\n",ntri);
          exit(1);
        }
        (*output)->ntri = ntri;
        for (i=0; i<ntri; i++){
          fscanf(fin,"%d %d %d",&i1,&i2,&i3);
          (*output)->triconn[3*i+0] = i1;
          (*output)->triconn[3*i+1] = i2;
          (*output)->triconn[3*i+2] = i3;
        }
        fscanf(fin,"%s",d1);
        while ( strcmp(d1,"SCALARS") != 0){
          fscanf(fin,"%s",d1);
        }
        fscanf(fin,"%s %s",d1,d2); 
        for (i=0; i<nvert; i++){
          fscanf(fin,"%f",&x);
          (*output)->vertData[i] = x;
        }

/* <---- END OF USER-SUPPLIED CODE SECTION #3                            */
	return(1);
}
 
/* ***********************************************************************/
/* Initialization for modules contained in this file.                    */
/* ***********************************************************************/
static int ((*mod_list[])()) = {
	ReadArrays_desc
};
#define NMODS (sizeof(mod_list) / sizeof(char *))

void
AVSinit_modules()
{
	AVSinit_from_module_list(mod_list, NMODS);
}
 
/* ----> START OF USER-SUPPLIED CODE SECTION #4 (SUBROUTINES, FUNCTIONS, UTILITY ROUTINES)*/
/* <---- END OF USER-SUPPLIED CODE SECTION #4                            */

