
#------------------------------------------------------------------------------
# STV_VIEWER_AVS5_DIR: See if the user gave us the location of Cumulvs viewer_avs5
# directory
# one must be present and contain the correct files, or else the user
# must give the directory that contains the correct files.
#------------------------------------------------------------------------------
# STV viewer_avs5 directory, must contain stv_viewer
AC_DEFUN(STV_FIND_VIEWER_AVS5_DIR,
[

#  CUMULVS viewer_avs5 search paths
stv_viewer_avs5_dirs="
    $CURRDIR_PARENT/avs
    $CURRDIR_GRANDPARENT/avs
    $CURRDIR_GREATGRANDPARENT/avs
    $CURRDIR_GREATGRANDPARENT/../avs
    $STV_ROOT/avs
    $HOME/projects/CUMULVS/avs
"

AC_ARG_WITH(stv_viewer_avs5, 
    [Location of the CUMULVS viewer_avs5 dir:
  --with-stv_viewer_avs5=STV_VIEWER_AVS5_DIR
                          The location of CUMULVS viewer_avs5 executables.
                          Give the full path:
                              --with-stv_viewer_avs5='$HOME/CUMULVS/avs/LINUX'
                          ] ,
    , [with_stv_viewer_avs5=no])

case "$with_stv_viewer_avs5" in
    no)
        # lUser input error
        with_stv_viewer_avs5=_searching
        ;;
    yes)
        #  User didn't give the option or didn't give useful
        #  information, search for it ourselves
        with_stv_viewer_avs5=_searching
        ;;
    *)
        STV_VIEWER_AVS5_DIR="$with_stv_viewer_avs5"
        ;;
esac

if test "$with_stv_viewer_avs5" = _searching ; then
    AC_MSG_CHECKING([for CUMULVS viewer avs5 executables directory])
    AC_MSG_RESULT([])
    stv_viewer_avs5_dir_found=0
    for chome in $stv_viewer_avs5_dirs ; do
        if test -d $chome ; then
	    AC_MSG_CHECKING([for $chome])
	    if test ! -d "$chome"  ; then
		AC_MSG_RESULT([no.])
	    else
		AC_MSG_RESULT([yes.])
		stv_viewer_avs5_dir_found=1
		with_stv_viewer_avs5=$chome/$PVM_ARCH
		with_stv_viewer_avs5_shared=$chome/$PVM_ARCH/shared
	    fi

	    if test "$stv_viewer_avs5_dir_found" = 1; then
	        break
	    fi
        fi
    done
fi


if test "$with_stv_viewer_avs5" = _searching ; then
    AC_MSG_RESULT([Cannot find Cumulvs viewer avs5 executables directory.])
    AC_MSG_ERROR([Please reinstall the CUMULVS AVS5 viewer source and/or use --with-stv_viewer_avs5=STV_VIEWER_AVS5_BIN_DIR.])
fi

if test ! "$stv_viewer_avs5_dir_found" = 1; then
    if test ! -f "$with_stv_viewer_avs5/stv_viewer"  ; then
    	AC_MSG_RESULT([No stv_viewer in $with_stv_viewer_avs5.])
    	AC_MSG_RESULT([Hope that's ok. If you use thr CUMULVS rpm use STV_FIND_VIEWER_AVS5_RPM_DIR configure macro!])
    fi
    with_stv_viewer_avs5_shared=$with_stv_viewer_avs5/shared
fi

STV_VIEWER_AVS5_DIR="$with_stv_viewer_avs5"
STV_VIEWER_AVS5_SHARED_DIR="$with_stv_viewer_avs5_shared"
AC_SUBST(STV_VIEWER_AVS5_DIR)
AC_SUBST(STV_VIEWER_AVS5_SHARED_DIR)
]
)
###########################################################################
# END: STV FIND VIEWER_AVS5 DIR M4 MACRO				  #
###########################################################################

