
#------------------------------------------------------------------------------
# STV_VIEWER_AVS5_RPM_DIR: See if the user gave us the location of Cumulvs viewer_avs5
# directory
# one must be present and contain the correct files, or else the user
# must give the directory that contains the correct files.
#------------------------------------------------------------------------------
# STV viewer_avs5 directory, must contain stv_viewer
AC_DEFUN(STV_FIND_VIEWER_AVS5_RPM_DIR,
[

#  CUMULVS viewer_avs5_rpm search paths
stv_viewer_avs5_rpm_dirs="
    $prefix/CUMULVS/examples/avs
    /usr/local/CUMULVS/examples/avs
    /usr/local/bin
"

AC_ARG_WITH(stv_viewer_avs5_rpm, 
    [Location of the CUMULVS viewer_avs5_rpm dir:
  --with-stv_viewer_avs5_rpm=STV_VIEWER_AVS5_RPM_DIR
                          The location of CUMULVS viewer_avs5 rpm executables.
                          Give the full path:
                              --with-stv_viewer_avs5_rpm='/usr/local/CUMULVS/avs'
                          ] ,
    , [with_stv_viewer_avs5_rpm=no])

case "$with_stv_viewer_avs5_rpm" in
    no)
        # lUser input error
        with_stv_viewer_avs5_rpm=_searching
        ;;
    yes)
        #  User didn't give the option or didn't give useful
        #  information, search for it ourselves
        with_stv_viewer_avs5_rpm=_searching
        ;;
    *)
        with_stv_viewer_avs5_shared_rpm=$with_stv_viewer_avs5_rpm
        ;;
esac

if test "$with_stv_viewer_avs5_rpm" = _searching ; then
    AC_MSG_CHECKING([for CUMULVS viewer avs5_rpm executables])
    AC_MSG_RESULT([])
    stv_viewer_avs5_rpm_dir_found=0
    for chome in $stv_viewer_avs5_rpm_dirs ; do
        if test -d $chome ; then
	    AC_MSG_CHECKING([for stv_viewer in $chome])
	    if test ! -f "$chome/stv_viewer"  ; then
		AC_MSG_RESULT([no.])
	    else
		AC_MSG_RESULT([yes.])
		stv_viewer_avs5_rpm_dir_found=1
		with_stv_viewer_avs5_rpm=$chome
		with_stv_viewer_avs5_shared_rpm=$chome
	    fi

	    if test "$stv_viewer_avs5_rpm_dir_found" = 1; then
	        break
	    fi
        fi
    done
fi
if test "$with_stv_viewer_avs5_rpm" = _searching ; then
    AC_MSG_RESULT([Cannot find Cumulvs viewer avs5 rpm executables.])
    AC_MSG_ERROR([Please reinstall the CUMULVS AVS5 viewer rpm and/or use --with-stv_viewer_avs5_rpm=STV_VIEWER_AVS5_RPM_DIR.])
fi

if test ! -f "$with_stv_viewer_avs5_rpm/stv_viewer"  ; then
    AC_MSG_RESULT([No stv_viewer in $with_stv_viewer_avs5_rpm.])
    AC_MSG_ERROR([Please reinstall the CUMULVS AVS5 viewer rpm and/or use --with-stv_viewer_avs5_rpm=STV_VIEWER_AVS5_RPM_BIN_DIR.])
fi

STV_VIEWER_AVS5_DIR="$with_stv_viewer_avs5_rpm"
STV_VIEWER_AVS5_SHARED_DIR="$with_stv_viewer_avs5_shared_rpm"
AC_SUBST(STV_VIEWER_AVS5_DIR)
AC_SUBST(STV_VIEWER_AVS5_SHARED_DIR)
]
)
###########################################################################
# END: STV FIND VIEWER_AVS5_RPM DIR M4 MACRO				  #
###########################################################################

