%define name cumulvs-avs
%define version 1.0.0
%define release 1mdk

Summary: AVS5 viewer for the CUMULVS library. CUMULVS is an infrastructure library that allows a programmer to easily extract data from a running parallel simulation and view the data with a visualization package.
Name: %{name}
Version: %{version}
Release: %{release}
Source0: %{name}-%{version}-%{release}.tar.gz
License: GPL
Group:  Development/Libraries
BuildRoot: %{_tmppath}/%{name}-buildroot
#Prefix: /usr/local

#provides:
# used for virtual package (if more then one can provide the requirements for other packages)

requires: cumulvs >= 1.3.0, glibc >= 2.3.1
AutoReqProv: no

%description
CUMULVS AVS rpm that creates all files required for the CUMULVS AVS5 viewer.

If you haven't already done so, you can download CUMULVS from:
   www.csm.ornl.gov/cs/cumulvs.html

If you are running LINUX you should consider using the binary RPM instead of the source distribution.

%prep
%setup -q

%build
./configure --prefix=$RPM_BUILD_ROOT/usr/local --with-stv_autoconf_macros_dir=$RPM_BUILD_ROOT/usr/local/CUMULVS/autoconf-macros

#prefix is needed for Mandrake in order to find all files during rpm build
make all

%install
make install

%clean
#only for cleaning up after the RPM build process
# WARNING, should check to first make sure that BuilRoot is not / !!!
if [ $RPM_BUILD_ROOT != "/" ]; then
   rm -rf $RPM_BUILD_ROOT
else
   make instclean
fi
rm -rf /usr/src/RPM/BUILD/%{name}-%{version}

%files
#files that get installed with complete path
/usr/local/CUMULVS/stv-avs-config
/usr/local/CUMULVS/autoconf-macros/stv_find_viewer_avs5_dir.m4
/usr/local/CUMULVS/autoconf-macros/stv_find_viewer_avs5_rpm_dir.m4
/usr/local/CUMULVS/examples/avs/stv_viewer
/usr/local/CUMULVS/examples/avs/stv_viewer_tri
/usr/local/CUMULVS/examples/avs/ReadArrays
/usr/local/CUMULVS/examples/avs/GenerateTris
/usr/local/CUMULVS/examples/avs/munge_material
/usr/local/CUMULVS/examples/avs/merge_coords
/usr/local/CUMULVS/examples/avs/basenet.net.in
/usr/local/CUMULVS/examples/avs/ccanet.net.in
/usr/local/CUMULVS/examples/avs/ccatri.net.in
/usr/local/CUMULVS/examples/avs/testnet2.net.in
/usr/local/CUMULVS/examples/avs/testnet.net.in
/usr/local/CUMULVS/examples/avs/testnetp.net.in
/usr/local/CUMULVS/examples/avs/stv_module_library
/usr/local/CUMULVS/examples/avs/tri.dat
/usr/local/CUMULVS/examples/avs/tags
/usr/local/CUMULVS/examples/avs/source/config/configure.in
/usr/local/CUMULVS/examples/avs/source/config/config.sub
/usr/local/CUMULVS/examples/avs/source/config/config.guess
/usr/local/CUMULVS/examples/avs/source/config/install-sh
/usr/local/CUMULVS/examples/avs/source/config/make-aclocal.m4.in
/usr/local/CUMULVS/examples/avs/source/config/new_aclocal_configure
/usr/local/CUMULVS/examples/avs/source/config/new_aclocal_configure.in
/usr/local/CUMULVS/examples/avs/source/configure
/usr/local/CUMULVS/examples/avs/source/GenerateTris.c
/usr/local/CUMULVS/examples/avs/source/Makefile.aimk.in
/usr/local/CUMULVS/examples/avs/source/Makefile.in
/usr/local/CUMULVS/examples/avs/source/merge_coords.c
/usr/local/CUMULVS/examples/avs/source/munge_material.c
/usr/local/CUMULVS/examples/avs/source/ReadArrays.c
/usr/local/CUMULVS/examples/avs/source/README
/usr/local/CUMULVS/examples/avs/source/stv_module_library
/usr/local/CUMULVS/examples/avs/source/stv_viewer.c
/usr/local/CUMULVS/examples/avs/source/stv_viewer_tri.c
/usr/local/CUMULVS/examples/avs/source/threshold.c
/usr/local/CUMULVS/examples/avs/source/triangleData.h

%defattr(-,root,root)


%post
#what to do after the rpm was installed - run stv-avs-config
cd /usr/local/CUMULVS
./stv-avs-config

%changelog

%preun
# run the sym link cleaner before deinstalling the rpm
#cd /usr/local/CUMULVS
#./stv-avs-uninst

%postun
#what to do after RPM got deinstalled from the system
#in this case just delete the created directory with all files
/bin/rm -rf /usr/local/CUMULVS/examples/avs
/bin/rm -f /usr/local/CUMULVS/stv-avs-config
/bin/rm -f /usr/local/CUMULVS/autoconf-macros/stv_find_viewer_avs5_dir.m4
/bin/rm -f /usr/local/CUMULVS/autoconf-macros/stv_find_viewer_avs5_rpm_dir.m4

# end of file
