%define name cumulvs-mpi
%define version 1.0.0
%define release 1mdk

Summary: MPI (Message Passing Interface) examples for the CUMULVS library. CUMULVS is an infrastructure library that allows a programmer to easily extract data from a running parallel simulation and view the data with a visualization package.
Name: %{name}
Version: %{version}
Release: %{release}
Source0: %{name}-%{version}-%{release}.tar.gz
License: GPL
Group:  Development/Libraries
BuildRoot: %{_tmppath}/%{name}-buildroot
#Prefix: /usr/local

#provides:
# used for virtual package (if more then one can provide the requirements for other packages)

requires: cumulvs

%description
CUMULVS mpi rpm that creates all example files required for CUMULVS examples using MPI.

If you haven't already done so, you can download CUMULVS from:
   www.csm.ornl.gov/cs/cuumulvs.html 

If you are running LINUX you should consider using the CUMULVS RPM instead of the source distribution.

%prep
%setup -q

%build
./configure --prefix=$RPM_BUILD_ROOT/usr/local
#prefix is needed for Mandrake in order to find all files during rpm build
make all

%install
make install

%clean
#only for cleaning up after the RPM build process
# WARNING, should check to first make sure that BuilRoot is not / !!!
if [ $RPM_BUILD_ROOT != "/" ]; then
   rm -rf $RPM_BUILD_ROOT
else
   make instclean
fi
rm -rf /usr/src/RPM/BUILD/%{name}-%{version}

%files
#files that get installed with complete path
/usr/local/bin/fsimple_mpi
/usr/local/CUMULVS/examples/mpi/fsimple_mpi.f
/usr/local/CUMULVS/examples/mpi/Makefile
/usr/local/CUMULVS/examples/mpi/Makefile.in
/usr/local/CUMULVS/examples/mpi/configure
/usr/local/CUMULVS/examples/mpi/config/configure.in
/usr/local/CUMULVS/examples/mpi/config/config.guess
/usr/local/CUMULVS/examples/mpi/config/config.sub
/usr/local/CUMULVS/examples/mpi/config/install-sh
/usr/local/CUMULVS/examples/mpi/config/make-aclocal.m4.in
/usr/local/CUMULVS/examples/mpi/config/new_aclocal_configure
/usr/local/CUMULVS/examples/mpi/config/new_aclocal_configure.in
/usr/local/CUMULVS/examples/mpi/README

%defattr(-,root,root)


%post
#what to do after the rpm was installed


%changelog

%preun
# run the sym link cleaner before deinstalling the rpm

%postun
#what to do after RPM got deinstalled from the system
#in this case just delete the created directory with all files
/bin/rm	-rf  /usr/local/CUMULVS/examples/mpi
/bin/rm /usr/local/bin/fsimple_mpi

# end of file
