
#include <time.h> // for gettimeofday 
#include <sys/time.h> 
#include <sys/resource.h>
#include <unistd.h>
#include <stdio.h> 

int main( int argc, char **argv ) 
{ 
	struct timeval tv1, tv2;
	struct rusage ru1, ru2;

	long elapsed, best_elapsed;
	long usage, best_usage;

	int i;

	for ( i=0 ; i < 1000 ; i++ )
	{
		gettimeofday( &tv1, NULL ); 
		do
		{ 
			gettimeofday( &tv2, NULL ); 
		}
		while ( tv1.tv_usec == tv2.tv_usec ); 

		elapsed = tv2.tv_usec - tv1.tv_usec
			+ 1000000 * (tv2.tv_sec - tv1.tv_sec); 

		if ( !i || elapsed < best_elapsed )
			best_elapsed = elapsed;
	}

	printf( "Resolution (gettimeofday): %ld us\n", best_elapsed );

	for ( i=0 ; i < 1000 ; i++ )
	{
		getrusage( RUSAGE_SELF, &ru1 ); 
		do
		{ 
			getrusage( RUSAGE_SELF, &ru2 ); 
		}
		while ( ru1.ru_utime.tv_usec == ru2.ru_utime.tv_usec ); 

		usage = ru2.ru_utime.tv_usec - ru1.ru_utime.tv_usec
			+ 1000000 * (ru2.ru_utime.tv_sec - ru1.ru_utime.tv_sec);

		if ( !i || usage < best_usage )
			best_usage = usage;
	}

	printf( "Resolution (getrusage user time): %ld us\n", best_usage );

	for ( i=0 ; i < 1000 ; i++ )
	{
		getrusage( RUSAGE_SELF, &ru1 ); 
		do
		{ 
			getrusage( RUSAGE_SELF, &ru2 ); 
		}
		while ( ru1.ru_stime.tv_usec == ru2.ru_stime.tv_usec ); 

		usage = ru2.ru_stime.tv_usec - ru1.ru_stime.tv_usec
			+ 1000000 * (ru2.ru_stime.tv_sec - ru1.ru_stime.tv_sec);

		if ( !i || usage < best_usage )
			best_usage = usage;
	}

	printf( "Resolution (getrusage sys time): %ld us\n", best_usage );

	return 0; 
} 

