
/* $Id: stv_proto.h,v 4.20 2003/09/10 16:54:50 kohl Exp $ */


/*
 *                      CUMULVS version 1.0:
 *      Computational Steering and Interactive Visualization
 *                   in Distributed Applications
 *           Oak Ridge National Laboratory, Oak Ridge TN.
 *      Authors:  James Arthur Kohl and Philip M. Papadopoulos
 *                   (C) 1996 All Rights Reserved
 *
 *                              NOTICE
 *
 * Permission to use, copy, modify, and distribute this software and
 * its documentation for any purpose and without fee is hereby granted
 * provided that the above copyright notice appear in all copies and
 * that both the copyright notice and this permission notice appear
 * in supporting documentation.
 *
 * Neither the Institution, Oak Ridge National Laboratory, nor the
 * Authors make any representations about the suitability of this
 * software for any purpose.  This software is provided ``as is''
 * without express or implied warranty.
 *
 * CUMULVS was funded by the U.S. Department of Energy.
 */


#ifndef _STV_PROTO_H_

#define _STV_PROTO_H_


/* CUMULVS System Library Routine Prototypes */


#ifdef __cplusplus
extern "C" {
#endif


STV_BUFPTR	stv_create_mbuffer __STV_Prototype__(( void ));

STV_BUFPTR	stv_recvMessage __STV_Prototype__(( STV_MP_API *,
					int, int, int, int, STV_CONTEXT, int ));


STV_COUPLER		stv_create_coupler __STV_Prototype__(( void ));

STV_COUPLER		stv_find_coupler __STV_Prototype__(( int ));

STV_COUPLER		stv_find_coupler_field __STV_Prototype__(( char *,
						int ));


STV_DECOMPPTR	stv_create_decomp __STV_Prototype__(( void ));

STV_DECOMPPTR	stv_findDecomp __STV_Prototype__(( STV_DECOMPPTR,
						int ));

STV_DECOMPPTR	stv_get_decomp __STV_Prototype__(( STV_DECOMPPTR,
						STV_DECOMPPTR, int ));


STV_FE_VIEWERPTR	stv_create_fe_viewer __STV_Prototype__(( void ));

STV_FE_VIEWERPTR	stv_findViewer __STV_Prototype__((
							STV_FE_VIEWERPTR, int ));


STV_FIELD_GROUP_PTR		stv_create_field_group __STV_Prototype__((
								void ));

STV_FIELD_GROUP_PTR		stv_findFieldGroup __STV_Prototype__((
								STV_FIELD_GROUP_PTR, int ));


STV_FIELD_MAP_PTR	stv_create_field_map __STV_Prototype__(( void ));

STV_FIELD_MAP_PTR	stv_get_field_map __STV_Prototype__(( int,
							STV_FIELD_MAP_PTR )); 


STV_FIELDPTR	stv_create_field __STV_Prototype__(( void ));

STV_FIELDPTR	stv_findField __STV_Prototype__(( STV_FIELDPTR, int ));

STV_FIELDPTR	stv_get_field_name __STV_Prototype__(( char *,
						STV_FIELDPTR, int ));

STV_FIELDPTR	stv_get_field_name_array __STV_Prototype__(( char *,
						STV_FIELDPTR *, int ));


STV_HANDLER	stv_create_handler __STV_Prototype__(( void ));


STV_MSG_PASS_THRU	stv_create_stv_msg_pass_thru __STV_Prototype__((
						void ));


STV_PACK_DIM	stv_create_pack_dim __STV_Prototype__(( void ));

STV_PACK_DIM	stv_get_SubRegion_index __STV_Prototype__((
						STV_FIELDPTR, STV_VIS_REGION, int, int,
						int * ));

STV_PACK_DIM	stv_get_SubRegion_indices __STV_Prototype__((
						STV_FIELDPTR, STV_VIS_REGION ));


STV_PACK_INDEX	stv_create_pack_index __STV_Prototype__(( void ));


STV_PARAM_MAP_PTR	stv_create_param_map __STV_Prototype__(( void ));

STV_PARAM_MAP_PTR	stv_get_param_map __STV_Prototype__(( int,
							STV_PARAM_MAP_PTR )); 


STV_PARAMPTR	stv_create_param __STV_Prototype__(( void ));

STV_PARAMPTR	stv_findParam __STV_Prototype__(( STV_PARAMPTR, int ));

STV_PARAMPTR	stv_get_param_name __STV_Prototype__(( char *,
						STV_PARAMPTR, int ));


STV_PARTICLEPTR		stv_create_particle __STV_Prototype__(( void ));

STV_PARTICLEPTR		stv_findParticle __STV_Prototype__((
							STV_PARTICLEPTR, int ));

STV_PARTICLEPTR		stv_get_particle __STV_Prototype__((
							STV_PARTICLEPTR, STV_PARTICLEPTR, int ));

STV_PARTICLEPTR		stv_get_particle_name __STV_Prototype__(( char *,
							STV_PARTICLEPTR, int ));

STV_PARTICLEPTR		stv_get_particle_name_vfg __STV_Prototype__((
							STV_VIEW_FIELD_GROUP, char * ));


STV_VALUE	stv_get_typed_ptr_offset __STV_Prototype__(( STV_VALUE,
					int, int ));


STV_VALUE_LIST	stv_create_value_list __STV_Prototype__(( void ));


STV_VIEW_DESC_INDEX		stv_create_view_desc_index();


STV_VIEW_DESCRIPTOR		stv_create_view_descriptor();


STV_VIEW_FIELD	stv_create_view_field __STV_Prototype__(( void ));

STV_VIEW_FIELD	stv_get_view_field_from_group_id __STV_Prototype__((
						STV_VIEW_FIELD_GROUP, int, int * ));

STV_VIEW_FIELD	stv_get_view_field_name __STV_Prototype__(( char *,
						STV_VIEW_FIELD, int ));


STV_VIEW_FIELD_GROUP	stv_add_vfg_to_viewer __STV_Prototype__((
								STV_VIEWER, STV_VIS_REGION, int, int ));

STV_VIEW_FIELD_GROUP	stv_create_view_field_group __STV_Prototype__((
								void ));

STV_VIEW_FIELD_GROUP	stv_get_steer_vfg __STV_Prototype__(( void ));

STV_VIEW_FIELD_GROUP	stv_get_view_field_group_id __STV_Prototype__((
								STV_VIEW_FIELD_GROUP, int, int ));

STV_VIEW_FIELD_GROUP	stv_make_view_field_group __STV_Prototype__((
								STV_VIEW_FIELD, int ));

STV_VIEW_FIELD_GROUP	stv_viewer_couple_field_request
							__STV_Prototype__((
								STV_VIEWER, STV_VIS_REGION, STV_COUPLER,
								int * ));

STV_VIEW_FIELD_GROUP	stv_viewer_request_field __STV_Prototype__((
								STV_VIEWER, STV_REGION, STV_CELL,
								int, int, int * ));

STV_VIEW_FIELD_GROUP	stv_viewer_request_static_field
							__STV_Prototype__((
								STV_VIEWER, STV_VIS_REGION,
								int, int, int * ));

STV_VIEW_FIELD_GROUP	stv_viewer_submit_field_request
							__STV_Prototype__((
								STV_VIEWER, STV_VIS_REGION,
								int, int, int * ));


STV_VIEW_PARAM	stv_create_view_param __STV_Prototype__(( void ));

STV_VIEW_PARAM	stv_get_view_param_id __STV_Prototype__(( int,
						STV_VIEW_PARAM, int ));

STV_VIEW_PARAM	stv_get_view_param_name __STV_Prototype__(( char *,
						STV_VIEW_PARAM, int ));


STV_VIEW_PARTICLE	stv_create_view_particle __STV_Prototype__((
							void ));

STV_VIEW_PARTICLE	stv_get_view_particle_name __STV_Prototype__((
							STV_VIEW_PARTICLE, char * ));


STV_VIEW_PARTICLE_DATA	stv_create_view_particle_data
								__STV_Prototype__(( void ));


STV_VIEW_TASK	stv_create_view_task __STV_Prototype__(( void ));

STV_VIEW_TASK	stv_get_view_task_tid __STV_Prototype__((
						int, STV_VIEW_TASK, int ));


STV_VIEWER	stv_create_viewer __STV_Prototype__(( void ));

STV_VIEWER	stv_find_viewer __STV_Prototype__(( int ));

STV_VIEWER	stv_get_viewer_by_app __STV_Prototype__(( char * ));


STV_VIS_REGION	stv_create_vis_region __STV_Prototype__(( void ));


double	stv_fabs __STV_Prototype__(( double ));


float	stv_time_ratio __STV_Prototype__(( int, int ));


void	stvSleep __STV_Prototype__(( int ));

void	stv_banner __STV_Prototype__(( void ));

void	stv_bump_field_times __STV_Prototype__(( STV_FIELDPTR, int ));

void	stv_check_decomp_axis_info __STV_Prototype__(( int, int,
				int *, int **, int **, int, int, int, int ));

void	stv_clear_view_field_select __STV_Prototype__(( STV_VIEWER ));

void	stv_copy_cell __STV_Prototype__(( STV_CELL, STV_CELL ));

void	stv_copy_region __STV_Prototype__(( STV_REGION, STV_REGION ));

void	stv_copy_vis_region __STV_Prototype__(( STV_VIS_REGION,
				STV_VIS_REGION ));

void	stv_dump_base_indices __STV_Prototype__(( int *, int,
				STV_VIS_REGION, int ));

void	stv_dump_debug_flag __STV_Prototype__(( int, int ));

void	stv_dump_field_array __STV_Prototype__(( STV_VALUE, int *, int,
				STV_VIS_REGION, int, int, int ));

void	stv_dump_pack_dims __STV_Prototype__(( STV_PACK_DIM,
				int, int ));

void	stv_dump_particle_field __STV_Prototype__((
				STV_VIEW_PARTICLE ));

void	stv_dump_time_constants __STV_Prototype__(( void ));

void	stv_dump_user_field_array __STV_Prototype__(( STV_VALUE, int *,
				int, int *, int, int, int ));

void	stv_dump_vfg_field_array __STV_Prototype__((
				STV_VIEW_FIELD_GROUP, int ));

void	stv_free_decomp __STV_Prototype__(( STV_DECOMPPTR * ));

void	stv_free_fe_viewer __STV_Prototype__(( STV_FE_VIEWERPTR * ));

void	stv_free_field __STV_Prototype__(( STV_FIELDPTR * ));

void	stv_free_field_array __STV_Prototype__((
				STV_VIEW_FIELD_GROUP, int ));

void	stv_free_field_group __STV_Prototype__((
				STV_FIELD_GROUP_PTR * ));

void	stv_free_field_group_list __STV_Prototype__((
				STV_FIELD_GROUP_PTR * ));

void	stv_free_field_map __STV_Prototype__(( STV_FIELD_MAP_PTR * ));

void	stv_free_field_map_list __STV_Prototype__((
				STV_FIELD_MAP_PTR * ));

void	stv_free_handler __STV_Prototype__(( STV_HANDLER * ));

void	stv_free_mbuffer __STV_Prototype__(( STV_BUFPTR * ));

void	stv_free_msg_pass_thru __STV_Prototype__((
				STV_MSG_PASS_THRU * ));

void	stv_free_pack_dim __STV_Prototype__(( STV_PACK_DIM * ));

void	stv_free_pack_dim_list __STV_Prototype__(( STV_PACK_DIM * ));

void	stv_free_pack_index __STV_Prototype__(( STV_PACK_INDEX * ));

void	stv_free_pack_index_list __STV_Prototype__((
				STV_PACK_INDEX * ));

void	stv_free_param __STV_Prototype__(( STV_PARAMPTR * ));

void	stv_free_param_map __STV_Prototype__(( STV_PARAM_MAP_PTR * ));

void	stv_free_param_map_list __STV_Prototype__((
				STV_PARAM_MAP_PTR * ));

void	stv_free_particle __STV_Prototype__(( STV_PARTICLEPTR * ));

void	stv_free_value_list __STV_Prototype__(( STV_VALUE_LIST * ));

void	stv_free_view_desc_index __STV_Prototype__((
				STV_VIEW_DESC_INDEX * ));

void	stv_free_view_descriptor __STV_Prototype__((
				STV_VIEW_DESCRIPTOR * ));

void	stv_free_view_field __STV_Prototype__(( STV_VIEW_FIELD * ));

void	stv_free_view_field_group __STV_Prototype__((
				STV_VIEW_FIELD_GROUP * ));

void	stv_free_view_param __STV_Prototype__(( STV_VIEW_PARAM * ));

void	stv_free_view_particle __STV_Prototype__((
				STV_VIEW_PARTICLE * ));

void	stv_free_view_particle_data __STV_Prototype__((
				STV_VIEW_PARTICLE_DATA * ));

void	stv_free_view_particle_data_list __STV_Prototype__((
				STV_VIEW_PARTICLE_DATA * ));

void	stv_free_view_particle_fields __STV_Prototype__((
				STV_VIEW_PARTICLE ));

void	stv_free_view_particle_list __STV_Prototype__((
				STV_VIEW_PARTICLE * ));

void	stv_free_view_task __STV_Prototype__(( STV_VIEW_TASK * ));

void	stv_free_view_task_list __STV_Prototype__((
				STV_VIEW_TASK * ));

void	stv_free_viewer __STV_Prototype__(( STV_VIEWER * ));

void	stv_free_vis_region __STV_Prototype__(( STV_VIS_REGION * ));

void	stv_incr_time __STV_Prototype__(( int *, int *, int, int ));

void	stv_init_cell __STV_Prototype__(( STV_CELL ));

void	stv_init_pack_indices __STV_Prototype__(( STV_PACK_DIM ));

void	stv_init_region __STV_Prototype__(( STV_REGION ));

void	stv_init_vis_region __STV_Prototype__(( STV_VIS_REGION ));

void	stv_removeFieldGroup __STV_Prototype__(( STV_FE_VIEWERPTR,
				STV_FIELD_GROUP_PTR ));

void	stv_removeViewer __STV_Prototype__(( STV_FE_VIEWERPTR ));

void	stv_reset_Field_Particles __STV_Prototype__((
				STV_VIEW_FIELD_GROUP ));

void	stv_send_viewer_FieldAck __STV_Prototype__(( STV_MP_API *,
				int, int, int, int, int ));

void	stv_send_viewer_FieldTime __STV_Prototype__(( STV_MP_API *,
				int, int, int, int, int, int ));

void	stv_set_app_shdw_name __STV_Prototype__(( char *, char *,
				char *, char * ));

void	stv_viewer_lookup_app_context __STV_Prototype__(( char *,
				STV_VIEWER ));

void	stv_viewer_release_field __STV_Prototype__((
				STV_VIEW_FIELD_GROUP *, STV_VIEWER ));

void	stv_viewer_reset __STV_Prototype__(( STV_VIEWER ));

void	stv_viewer_send_AppLock __STV_Prototype__((
				STV_VIEW_FIELD_GROUP, STV_VIEWER, int ));

void	stv_viewer_send_AppUnlock __STV_Prototype__((
				STV_VIEW_FIELD_GROUP, STV_VIEWER ));

void	stv_viewer_send_FieldHaltAll __STV_Prototype__((
				STV_VIEW_FIELD_GROUP, STV_VIEWER ));

void	stv_viewer_send_FieldHaltGroup __STV_Prototype__((
				STV_VIEW_FIELD_GROUP, STV_VIEWER ));

void	stv_viewer_send_FieldRqst __STV_Prototype__((
				STV_VIEW_FIELD_GROUP, STV_VIEWER, int ));

void	stv_viewer_send_FieldTstart __STV_Prototype__((
				STV_VIEW_FIELD_GROUP, STV_VIEWER, int ));

void	stv_viewer_send_Init0 __STV_Prototype__(( STV_VIEWER, int ));

void	stv_viewer_send_Setopt __STV_Prototype__((
				STV_VIEW_FIELD_GROUP, STV_VIEWER, int, int, int ));

void	stv_viewer_send_TimeSync __STV_Prototype__((
				STV_VIEW_FIELD_GROUP, STV_VIEWER ));

void	stv_viewer_send_VisFrequency __STV_Prototype__((
				STV_VIEW_FIELD_GROUP, STV_VIEWER ));

void	stv_viewer_send_XON __STV_Prototype__(( STV_VIEW_FIELD_GROUP,
				STV_VIEWER ));

void	stv_viewer_set_VisFrequency __STV_Prototype__((
				STV_VIEW_FIELD_GROUP, STV_VIEWER, int ));


char	*cpd_read_str __STV_Prototype__(( int ));

char	*stv_copy_str __STV_Prototype__(( char * ));
char	*stv_data_type_str __STV_Prototype__(( int ));
char	*stv_debug_flag_str __STV_Prototype__(( int ));
char	*stv_decomp_type_str __STV_Prototype__(( int ));
char	*stv_msg_op_str __STV_Prototype__(( int ));
char	*stv_option_str __STV_Prototype__(( int ));
char	*stv_steering_group __STV_Prototype__(( STV_VIEW_PARAM ));
char	*stv_storage_order_str __STV_Prototype__(( int ));
char	*stv_str_of_typed_data __STV_Prototype__(( STV_VALUE, int ));
char	*stv_time_unit_str __STV_Prototype__(( int ));
char	*stv_version __STV_Prototype__(( void ));
char	*stv_version_name __STV_Prototype__(( void ));


int		*stv_add_to_list __STV_Prototype__(( int *, int, int ));


int		stv_add_handler __STV_Prototype__(( STV_HANDLER *, int *,
				STV_HANDLER_PROC, int, int, int, STV_CONTEXT ));

int		stv_add_msg_pass_thru __STV_Prototype__(( int ));

int		stv_allocate_Field_Data __STV_Prototype__((
				STV_VIEW_FIELD_GROUP, int, int ));

int		stv_allocate_Field_arrayDecl __STV_Prototype__((
				STV_VIEW_FIELD_GROUP, int ));

int		stv_calculate_eff_freq __STV_Prototype__(( int, int ));

int		stv_check_handler __STV_Prototype__(( STV_HANDLER, int,
						int, int, int, STV_CONTEXT ));

int		stv_check_region __STV_Prototype__(( STV_FIELDPTR,
				STV_VIS_REGION ));

int		stv_check_view_field_group_notify __STV_Prototype__((
				STV_VIEWER, int ));

int		stv_check_view_field_group_task __STV_Prototype__((
				STV_VIEW_FIELD_GROUP, int ));

int		stv_check_viewer_notify __STV_Prototype__(( STV_VIEWER, int ));

int		stv_clean_view_field_group_tids __STV_Prototype__((
				STV_VIEW_FIELD_GROUP, STV_VIEWER ));

int		stv_clrRecvBuffers __STV_Prototype__(( STV_BUFPTR,
				int, int * ));

int		stv_copy_converted_data __STV_Prototype__(( STV_VALUE, int,
				STV_VALUE, int ));

int		stv_copy_converted_data_elem __STV_Prototype__((
				STV_VALUE, int, int, STV_VALUE, int, int ));

int		stv_couple_fields __STV_Prototype__(( int, char *, char *,
					int, int, int, int, int ));

int		stv_couple_finished __STV_Prototype__(( int ));

int		stv_decompAddExplicitBounds __STV_Prototype__(( int,
				int, int, int ));

int		stv_decompAddExplicitVBounds __STV_Prototype__(( int,
				int, int *, int *, int ));

int		stv_decompAddExplicitPatch __STV_Prototype__(( int,
				int *, int * ));

int		stv_decompDefine __STV_Prototype__(( int, int *, int *, int *,
				int *, int *, int, int * ));

int		stv_define_message_handlers __STV_Prototype__(( void ));

int		stv_delete_handler __STV_Prototype__(( STV_HANDLER *, int *,
				STV_HANDLER_PROC, int, int, int, STV_CONTEXT ));

int		stv_delete_msg_pass_thru __STV_Prototype__(( int ));

int		stv_do_sendReadyData __STV_Prototype__(( int, int, int ));

int		stv_dump_time_str __STV_Prototype__(( FILE *, int, int ));

int		stv_dumpLocalFieldBounds __STV_Prototype__(( int, int ));

int		stv_field_region_overlap __STV_Prototype__(( STV_FIELDPTR,
				STV_VIS_REGION, STV_PACK_DIM * ));

int		stv_fieldAddExplicitDataPtr __STV_Prototype__(( int, int,
				STV_VALUE, int *, int * ));

int		stv_fieldAddExplicitVDataPtrs __STV_Prototype__(( int, int,
				STV_VALUE *, int **, int **, int ));

int		stv_fieldDefine __STV_Prototype__(( STV_VALUE, char *, int,
				int *, int *, int, int *, int ));

int		stv_fieldSetDataCallback __STV_Prototype__(( int,
				STV_DATA_CALLBACK ));

int		stv_generate_field_regions __STV_Prototype__(( STV_COUPLER,
				STV_VIS_REGION *, int * ));

int		stv_get_pack_offset __STV_Prototype__(( STV_PACK_DIM,
				STV_FIELDPTR, int, STV_VALUE * ));

int		stv_get_proc_dim_size __STV_Prototype__(( int, int, int,
				int **, int **, int, int, int, int ));

int		stv_get_remaining_params __STV_Prototype__(( void ));

int		stv_get_storage_stride __STV_Prototype__(( int *, STV_DECOMPPTR,
				int, int ));

int		stv_get_unpack_offset __STV_Prototype__(( int *, int *,
				STV_DECOMPPTR, STV_VIS_REGION, int, int ));

int		stv_getopt __STV_Prototype__(( int, int ));

int		stv_handleMessages __STV_Prototype__(( STV_MP_API *,
				int, int, int, STV_CONTEXT, int ));

int		stv_incr_field_index __STV_Prototype__(( int, int *, int *,
				STV_VIS_REGION, int, int ));

int		stv_incr_pack_indices __STV_Prototype__(( STV_PACK_DIM ));

int		stv_init __STV_Prototype__(( char *, int, int, int ));

int		stv_init_system __STV_Prototype__(( int ));

int		stv_isParamChanged __STV_Prototype__(( int ));

int		stv_match_cell __STV_Prototype__(( STV_CELL, STV_CELL, int ));

int		stv_match_decomp __STV_Prototype__(( STV_DECOMPPTR,
				STV_DECOMPPTR ));

int		stv_match_field __STV_Prototype__(( STV_FIELDPTR,
				STV_FIELDPTR ));

int		stv_match_param __STV_Prototype__(( STV_PARAMPTR,
				STV_PARAMPTR ));

int		stv_match_particle __STV_Prototype__(( STV_PARTICLEPTR,
				STV_PARTICLEPTR ));

int		stv_match_region __STV_Prototype__(( STV_REGION, STV_REGION,
				int ));

int		stv_match_vis_region __STV_Prototype__(( STV_VIS_REGION,
				STV_VIS_REGION, int ));

int		stv_mcast_incl_msg __STV_Prototype__(( STV_MP_API *, int,
				int *, int, int, STV_CONTEXT ));

int		stv_memcheck __STV_Prototype__(( void *, char * ));

int		stv_normalize_time_of __STV_Prototype__(( int, int ));

int		stv_num_visregions __STV_Prototype__(( STV_VIS_REGION ));

int		stv_pack_app_info __STV_Prototype__(( STV_MP_API *, int,
				int, STV_PARAMPTR, int, STV_FIELDPTR, int, int ));

int		stv_pack_by_type __STV_Prototype__(( STV_MP_API *,
				int, STV_VALUE, int, int, int ));

int		stv_pack_converted_type __STV_Prototype__(( STV_MP_API *,
				int, STV_VALUE, int, int, int, int ));

int		stv_pack_elems_SubRegion __STV_Prototype__(( STV_MP_API *, int,
				STV_PACK_DIM, STV_FIELDPTR, int, int ));

int		stv_pack_offset_index __STV_Prototype__(( STV_MP_API *,
				int, STV_PACK_DIM ));

int		stv_pack_SubRegion __STV_Prototype__(( STV_FE_VIEWERPTR,
				STV_FIELD_GROUP_PTR, int, STV_CONTEXT ));

int		stv_pack_SubRegion_Particles __STV_Prototype__(( int,
				STV_FE_VIEWERPTR, STV_FIELD_GROUP_PTR, int ));

int		stv_paramDefine __STV_Prototype__(( char *, STV_VALUE,
				int, int ));

int		stv_parse_freq_str __STV_Prototype__(( char *, int *, int ));

int		stv_particleDefine __STV_Prototype__(( char *, int,
				int *, int *, int, STV_GET_PARTICLE, STV_VALUE,
				STV_MAKE_PARTICLE, STV_VALUE ));

int		stv_particleFieldDefine __STV_Prototype__(( char *, int,
				int, int, STV_GET_PFIELD, STV_SET_PFIELD, int ));

int		stv_particle_set_local_subregion __STV_Prototype__(( int,
				int *, int * ));

int		stv_particle_in_region __STV_Prototype__(( STV_REGION,
				int *, int ));

int		stv_pfieldDefine __STV_Prototype__(( char *, int, int, int,
				STV_GET_PFIELD, STV_VALUE, STV_SET_PFIELD, STV_VALUE,
				int ));

int		stv_protoAppLock __STV_Prototype__(( STV_BUFPTR ));
int		stv_protoAppUnlock __STV_Prototype__(( STV_BUFPTR ));
int		stv_protoExchangeFieldTime __STV_Prototype__(( STV_BUFPTR ));
int		stv_protoFieldAck __STV_Prototype__(( STV_BUFPTR ));
int		stv_protoFieldBumpThold __STV_Prototype__(( STV_BUFPTR ));
int		stv_protoFieldHaltAll __STV_Prototype__(( STV_BUFPTR ));
int		stv_protoFieldHaltGroup __STV_Prototype__(( STV_BUFPTR ));
int		stv_protoFieldTime __STV_Prototype__(( STV_BUFPTR ));
int		stv_protoFieldTstart __STV_Prototype__(( STV_BUFPTR ));
int		stv_protoFieldRqst __STV_Prototype__(( STV_BUFPTR ));
int		stv_protoInit0 __STV_Prototype__(( STV_BUFPTR ));
int		stv_protoInit1 __STV_Prototype__(( STV_BUFPTR ));
int		stv_protoNewParams __STV_Prototype__(( STV_BUFPTR ));
int		stv_protoRegion __STV_Prototype__(( STV_BUFPTR ));
int		stv_protoSetopt __STV_Prototype__(( STV_BUFPTR ));
int		stv_protoSteerRelease __STV_Prototype__(( STV_BUFPTR ));
int		stv_protoTimeSync __STV_Prototype__(( STV_BUFPTR ));
int		stv_protoVisFrequency __STV_Prototype__(( STV_BUFPTR ));
int		stv_protoVisRegion __STV_Prototype__(( STV_BUFPTR ));
int		stv_protoXon __STV_Prototype__(( STV_BUFPTR ));

int		stv_protoNotify __STV_Prototype__(( STV_BUFPTR ));
int		stv_protoUlibNotify __STV_Prototype__(( STV_BUFPTR ));
int		stv_protoViewerNotify __STV_Prototype__(( STV_BUFPTR ));

int		stv_reconcile_times __STV_Prototype__((
				int *, int *, int *, int * ));

int		stv_reconfigure __STV_Prototype__(( void ));

int		stv_sendReadyData __STV_Prototype__(( int ));

int		stv_sendReadyDataBegin __STV_Prototype__(( int ));
int		stv_sendReadyDataTest __STV_Prototype__(( int ));
int		stv_sendReadyDataEnd __STV_Prototype__(( int ));

int		stv_sendToFE __STV_Prototype__(( void ));

int		stv_setopt __STV_Prototype__(( int, int, int ));

int		stv_sys_ok __STV_Prototype__(( char *, int ));

int		stv_time_of_double __STV_Prototype__(( double, int ));

int		stv_time_unit_of __STV_Prototype__(( char * ));

int		stv_transfer_coupled_data __STV_Prototype__(( STV_COUPLER,
				int ));

int		stv_unpack_app_info __STV_Prototype__(( STV_MP_API *, int,
				int *, STV_PARAMPTR **, int *,
				STV_FIELDPTR **, int * ));

int		stv_unpack_by_type __STV_Prototype__(( STV_MP_API *,
				int, STV_VALUE, int, int, int ));

int		stv_unpack_elems_SubRegion __STV_Prototype__(( STV_MP_API *,
				int, STV_VIEW_FIELD_GROUP, STV_VIEWER ));

int		stv_unpack_elems_SubRegion_Particles __STV_Prototype__((
				STV_MP_API *, int, STV_VIEW_FIELD_GROUP ));

int		stv_update_new_params __STV_Prototype__(( STV_FE_VIEWERPTR,
				STV_FIELD_GROUP_PTR ));

int		stv_userInitSend __STV_Prototype__(( int, int ));

int		stv_userMcast __STV_Prototype__(( int *, int, int ));

int		stv_userRecv __STV_Prototype__(( int, int, int ));

int		stv_userSend __STV_Prototype__(( int, int ));

int		stv_vector_handler __STV_Prototype__(( STV_HANDLER, int,
				STV_BUFPTR ));

int		stv_verify_context __STV_Prototype__(( char *, char *,
				STV_CONTEXT *, int, int ));

int		stv_verify_system_contexts __STV_Prototype__(( int, int ));

int		stv_viewer_bump_thold __STV_Prototype__(( STV_VIEW_FIELD_GROUP,
				STV_VIEWER ));

int		stv_viewer_exchange_FieldTime __STV_Prototype__(( STV_VIEWER,
				STV_COUPLER ));

int		stv_viewer_FieldRqst __STV_Prototype__(( STV_VIEW_FIELD_GROUP,
				STV_VIEWER, int, int * ));

int		stv_viewer_init __STV_Prototype__(( STV_VIEWER *,
				int, char *, int ));

int		stv_viewer_lookup_app_group __STV_Prototype__(( char *,
				int *, int ));

int		stv_viewer_recv_FieldAcks __STV_Prototype__((
				STV_VIEW_FIELD_GROUP, STV_VIEWER ));

int		stv_viewer_recv_FieldTime __STV_Prototype__((
				STV_VIEW_FIELD_GROUP, STV_VIEWER ));

int		stv_viewer_recv_Init1 __STV_Prototype__(( STV_VIEWER ));

int		stv_viewer_recv_Region __STV_Prototype__((
				STV_VIEW_FIELD_GROUP *, STV_VIEWER, int ));

int		stv_viewer_receive_frame __STV_Prototype__((
				STV_VIEW_FIELD_GROUP *, STV_VIEWER, int *, int ));

int		stv_viewer_send_NewParams __STV_Prototype__(( STV_VIEWER ));

int		stv_viewer_send_NewParamsScheduled __STV_Prototype__((
				STV_VIEWER, int ));

int		stv_viewer_send_VisRegion __STV_Prototype__((
				STV_VIEW_FIELD_GROUP, STV_VIEWER ));

int		stv_viewer_set_VisRegion __STV_Prototype__((
				STV_VIEW_FIELD_GROUP, STV_VIEWER,
				STV_VIS_REGION ));

int		stv_viewer_steer_parameter __STV_Prototype__(( STV_VIEW_PARAM,
				STV_VALUE, int ));

int		stv_viewer_steer_vparameter __STV_Prototype__(( STV_VIEW_PARAM,
				STV_VALUE, int, int ));

int		stv_viewer_steering_init __STV_Prototype__(( STV_VIEWER,
				int, int, int * ));

int		stv_viewer_steering_release __STV_Prototype__(( STV_VIEW_PARAM,
				STV_VIEWER ));

int		stv_viewer_steering_request __STV_Prototype__(( STV_VIEW_PARAM,
				STV_VIEWER, int ));

int		stv_vparamDefine __STV_Prototype__(( char *, STV_VALUE *,
				char **, int *, int, int ));

int		stv_wrapRecv __STV_Prototype__(( int, int, int ));

int		stv_gaDefine __STV_Prototype__(( int ));


#ifdef STV_MP_PVM

int		stv_mp_pvm_myid __STV_Prototype__(( int * ));
int		stv_mp_pvm_exit __STV_Prototype__(( void ));

int		stv_mp_pvm_create_context __STV_Prototype__(( int * ));
int		stv_mp_pvm_free_context __STV_Prototype__(( int * ));
int		stv_mp_pvm_get_context __STV_Prototype__(( int * ));
int		stv_mp_pvm_set_context __STV_Prototype__(( int, int * ));

int		stv_mp_pvm_init_msg_buf __STV_Prototype__(( int, int * ));
int		stv_mp_pvm_msg_buf_info __STV_Prototype__(( int,
				int *, int *, int * ));
int		stv_mp_pvm_get_sbuf __STV_Prototype__(( int * ));
int		stv_mp_pvm_set_sbuf __STV_Prototype__(( int ));
int		stv_mp_pvm_get_rbuf __STV_Prototype__(( int * ));
int		stv_mp_pvm_set_rbuf __STV_Prototype__(( int ));
int		stv_mp_pvm_free_msg_buf __STV_Prototype__(( int ));

int		stv_mp_pvm_pack_byte __STV_Prototype__(( int,
				void *, int, int ));
int		stv_mp_pvm_pack_int __STV_Prototype__(( int,
				void *, int, int ));
int		stv_mp_pvm_pack_float __STV_Prototype__(( int,
				void *, int, int ));
int		stv_mp_pvm_pack_double __STV_Prototype__(( int,
				void *, int, int ));
int		stv_mp_pvm_pack_complex __STV_Prototype__(( int,
				void *, int, int ));
int		stv_mp_pvm_pack_dcomplex __STV_Prototype__(( int,
				void *, int, int ));
int		stv_mp_pvm_pack_short __STV_Prototype__(( int,
				void *, int, int ));
int		stv_mp_pvm_pack_ushort __STV_Prototype__(( int,
				void *, int, int ));
int		stv_mp_pvm_pack_uint __STV_Prototype__(( int,
				void *, int, int ));
int		stv_mp_pvm_pack_long __STV_Prototype__(( int,
				void *, int, int ));
int		stv_mp_pvm_pack_ulong __STV_Prototype__(( int,
				void *, int, int ));
int		stv_mp_pvm_pack_str __STV_Prototype__(( int, char * ));
int		stv_mp_pvm_pack_context __STV_Prototype__(( int, int * ));

int		stv_mp_pvm_unpack_byte __STV_Prototype__(( int,
				void *, int, int ));
int		stv_mp_pvm_unpack_int __STV_Prototype__(( int,
				void *, int, int ));
int		stv_mp_pvm_unpack_float __STV_Prototype__(( int,
				void *, int, int ));
int		stv_mp_pvm_unpack_double __STV_Prototype__(( int,
				void *, int, int ));
int		stv_mp_pvm_unpack_complex __STV_Prototype__(( int,
				void *, int, int ));
int		stv_mp_pvm_unpack_dcomplex __STV_Prototype__(( int,
				void *, int, int ));
int		stv_mp_pvm_unpack_short __STV_Prototype__(( int,
				void *, int, int ));
int		stv_mp_pvm_unpack_ushort __STV_Prototype__(( int,
				void *, int, int ));
int		stv_mp_pvm_unpack_uint __STV_Prototype__(( int,
				void *, int, int ));
int		stv_mp_pvm_unpack_long __STV_Prototype__(( int,
				void *, int, int ));
int		stv_mp_pvm_unpack_ulong __STV_Prototype__(( int,
				void *, int, int ));
int		stv_mp_pvm_unpack_str __STV_Prototype__(( int, char * ));
int		stv_mp_pvm_unpack_context __STV_Prototype__(( int, int * ));

int		stv_mp_pvm_join_group __STV_Prototype__(( char *, int * ));
int		stv_mp_pvm_leave_group __STV_Prototype__(( char * ));
int		stv_mp_pvm_group_size __STV_Prototype__(( char *, int * ));
int		stv_mp_pvm_get_id_from_inst __STV_Prototype__(( char *,
				int, int * ));
int		stv_mp_pvm_get_inst_from_id __STV_Prototype__(( char *,
				int, int * ));
int		stv_mp_pvm_get_group_tids __STV_Prototype__(( char *,
				int **, int * ));

int		stv_mp_pvm_send_msg __STV_Prototype__(( int, int, int, int ));
int		stv_mp_pvm_mcast_msg __STV_Prototype__(( int,
				int *, int, int, int ));
int		stv_mp_pvm_bcast_msg __STV_Prototype__(( int, char *,
				int, int ));

int		stv_mp_pvm_recv_msg __STV_Prototype__(( int, int, int, int * ));
int		stv_mp_pvm_recv_msg_noblock __STV_Prototype__(( int,
				int, int, int * ));
int		stv_mp_pvm_recv_msg_timeout __STV_Prototype__(( int,
				int, int, struct timeval *, int * ));

int		stv_mp_pvm_perr __STV_Prototype__(( char * ));

#endif


#ifdef __cplusplus
}
#endif


/* _STV_PROTO_H_ */
#endif

