%define name cumulvs
%define version 1.3.0
%define release 1mdk9.1

Summary: CUMULVS is an infrastructure library that allows a programmer to easily extract data from a running parallel simulation and view the data with a visualization package.
Name: %{name}
Version: %{version}
Release: %{release}
Source0: %{name}-%{version}-%{release}.tar.gz
License: GPL
Group:  Development/Libraries
BuildRoot: %{_tmppath}/%{name}-buildroot
#Prefix: /usr/local

#provides:
# used for virtual package (if more then one can provide the requirements for other packages)

%description
CUMULVS rpm that creates all files required for using CUMULVS (like cumulvs libraries and headers as well as simple examples and viewers).

If you haven't already done so, you can download CUMULVS from:
   www.csm.ornl.gov/cs/cuumulvs.html 

If you are running LINUX you should consider using the CUMULVS RPM instead of the source distribution.

%prep
%setup -q

%build
./configure --prefix=$RPM_BUILD_ROOT/usr/local --with-stv_script_prefix=/usr/local --with-cumulvs=/usr/src/RPM/BUILD/%{name}-%{version}
#prefix is needed for Mandrake in order to find all files during rpm build
make base_package

%install
make install_base

%clean
#only for cleaning up after the RPM build process
# WARNING, should check to first make sure that BuilRoot is not / !!!
if [ $RPM_BUILD_ROOT != "/" ]; then
   rm -rf $RPM_BUILD_ROOT
else
   make instclean
fi
rm -rf /usr/src/RPM/BUILD/%{name}-%{version}

%files
#files that get installed with complete path
/usr/local/lib/libfstv.a
/usr/local/lib/libstv.a
/usr/local/lib/libfstv.so
/usr/local/lib/libstv.so
/usr/local/lib/libcpd.a
/usr/local/lib/libfcpd.a
/usr/local/lib/libcpd.so
/usr/local/lib/libfcpd.so
/usr/local/CUMULVS/makeincl/Makeincl.mp.PVM
/usr/local/CUMULVS/makeincl/Makeincl.stv
/usr/local/CUMULVS/makeincl/Makeincl.vis.AVS
/usr/local/CUMULVS/makeincl/Makeincl.vis.NONE
/usr/local/CUMULVS/makeincl/Makeincl.vis.TCLTK
/usr/local/CUMULVS/makeincl/Makeincl.mp.PVM.in
/usr/local/CUMULVS/makeincl/Makeincl.stv.in
/usr/local/CUMULVS/makeincl/Makeincl.vis.AVS.in
/usr/local/CUMULVS/makeincl/Makeincl.vis.NONE.in
/usr/local/CUMULVS/makeincl/Makeincl.vis.TCLTK.in
/usr/local/CUMULVS/stvconfig
/usr/local/CUMULVS/stvuninst
/usr/local/CUMULVS/config/install-sh
/usr/local/CUMULVS/config/cpi.c
/usr/local/CUMULVS/config/cpi.cpp
/usr/local/CUMULVS/bin/stvmk.in
/usr/local/CUMULVS/bin/aimk.in
/usr/local/CUMULVS/bin/stvmk
/usr/local/CUMULVS/bin/aimk
/usr/local/CUMULVS/autoconf-macros/stv_find_autoconf_macros_dir.m4
/usr/local/CUMULVS/autoconf-macros/stv_find_bin_dir.m4
/usr/local/CUMULVS/autoconf-macros/stv_find_lib_cumulvs.m4
/usr/local/CUMULVS/autoconf-macros/stv_find_rpm_root_dir.m4
/usr/local/CUMULVS/autoconf-macros/stv_find_source_root_dir.m4
/usr/local/CUMULVS/autoconf-macros/stv_find_config_dir.m4
/usr/local/CUMULVS/autoconf-macros/stv_lib_cave.m4
/usr/local/CUMULVS/autoconf-macros/stv_lib_mpi.m4
/usr/local/CUMULVS/autoconf-macros/stv_lib_pvm.m4
/usr/local/CUMULVS/autoconf-macros/stv_lib_tcltk.m4
/usr/local/CUMULVS/autoconf-macros/stv_lib_vtk.m4
/usr/local/CUMULVS/autoconf-macros/stvmain.m4
/usr/local/CUMULVS/autoconf-macros/stv_prog_avs.m4
/usr/local/CUMULVS/autoconf-macros/stv_select_cumulvs_mp.m4
/usr/local/CUMULVS/autoconf-macros/make-aclocal.m4.in
/usr/local/CUMULVS/autoconf-macros/new_aclocal_configure.in
/usr/local/CUMULVS/autoconf-macros/new_aclocal_configure
/usr/local/include/stv_glob.h
/usr/local/include/stvmac.h
/usr/local/include/stv_mp.h
/usr/local/include/stv_type.h
/usr/local/include/stv_proto.h
/usr/local/include/stv.h
/usr/local/include/fstv.h
/usr/local/include/cpd_proto.h
/usr/local/bin/cpd
/usr/local/bin/cpdcons
/usr/local/bin/cpdinfo
/usr/local/bin/cpdtest
/usr/local/bin/charge
/usr/local/bin/charge_coupled
/usr/local/bin/checkers
/usr/local/bin/checkersP
/usr/local/bin/cplane
/usr/local/bin/csimple
/usr/local/bin/csimple2
/usr/local/bin/fcloud_nocp
/usr/local/bin/flaplace
/usr/local/bin/fplane
/usr/local/bin/fsimple
/usr/local/bin/laplace
/usr/local/bin/laplaceC
/usr/local/bin/steerer
/usr/local/bin/trick
/usr/local/bin/tsimple
/usr/local/bin/tviewer
/usr/local/bin/viewer
/usr/local/bin/vsimple
/usr/local/bin/waves
/usr/local/CUMULVS/examples/src/apptest.c
/usr/local/CUMULVS/examples/src/charge.c
/usr/local/CUMULVS/examples/src/charge_coupled.c
/usr/local/CUMULVS/examples/src/checkers.c
/usr/local/CUMULVS/examples/src/checkersP.c
/usr/local/CUMULVS/examples/src/cktime.c
/usr/local/CUMULVS/examples/src/cp_charge.c
/usr/local/CUMULVS/examples/src/cplane.c
/usr/local/CUMULVS/examples/src/csimple.c
/usr/local/CUMULVS/examples/src/csimple2.c
/usr/local/CUMULVS/examples/src/fcloud_nocp.f
/usr/local/CUMULVS/examples/src/fcloud.f
/usr/local/CUMULVS/examples/src/fcloud_rs.f
/usr/local/CUMULVS/examples/src/flaplace.f
/usr/local/CUMULVS/examples/src/flaplace.inc
/usr/local/CUMULVS/examples/src/fplane.f
/usr/local/CUMULVS/examples/src/fsimple.f
/usr/local/CUMULVS/examples/src/laplace.c
/usr/local/CUMULVS/examples/src/laplaceC.c
/usr/local/CUMULVS/examples/src/Makefile
/usr/local/CUMULVS/examples/src/Makefile.aimk
/usr/local/CUMULVS/examples/src/Makefile.aimk.in
/usr/local/CUMULVS/examples/src/Makefile.in
/usr/local/CUMULVS/examples/src/README
/usr/local/CUMULVS/examples/src/steerer.c
/usr/local/CUMULVS/examples/src/tags
/usr/local/CUMULVS/examples/src/timer.c
/usr/local/CUMULVS/examples/src/trick.c
/usr/local/CUMULVS/examples/src/tri.dat
/usr/local/CUMULVS/examples/src/tsimple.c
/usr/local/CUMULVS/examples/src/tviewer.c
/usr/local/CUMULVS/examples/src/viewer.c
/usr/local/CUMULVS/examples/src/vsimple.c
/usr/local/CUMULVS/examples/src/waves.c
/usr/local/CUMULVS/examples/flyme/flyme.tcl
/usr/local/CUMULVS/examples/flyme/procs.tcl
/usr/local/CUMULVS/examples/flyme/util.tcl
/usr/local/CUMULVS/examples/flyme/xbm/down.xbm
/usr/local/CUMULVS/examples/flyme/xbm/left.xbm
/usr/local/CUMULVS/examples/flyme/xbm/ne.xbm
/usr/local/CUMULVS/examples/flyme/xbm/nw.xbm
/usr/local/CUMULVS/examples/flyme/xbm/right.xbm
/usr/local/CUMULVS/examples/flyme/xbm/se.xbm
/usr/local/CUMULVS/examples/flyme/xbm/sw.xbm
/usr/local/CUMULVS/examples/flyme/xbm/up.xbm
/usr/local/CUMULVS/examples/flyme/commands.c
/usr/local/CUMULVS/examples/flyme/const.h
/usr/local/CUMULVS/examples/flyme/cp_region.c
/usr/local/CUMULVS/examples/flyme/flyme.c
/usr/local/CUMULVS/examples/flyme/flyme_glob.c
/usr/local/CUMULVS/examples/flyme/flyme_glob.h
/usr/local/CUMULVS/examples/flyme/flyme.h
/usr/local/CUMULVS/examples/flyme/flyme.h.in
/usr/local/CUMULVS/examples/flyme/flyme.tcl.src
/usr/local/CUMULVS/examples/flyme/heli.c
/usr/local/CUMULVS/examples/flyme/Makefile
/usr/local/CUMULVS/examples/flyme/Makefile.aimk
/usr/local/CUMULVS/examples/flyme/Makefile.aimk.in
/usr/local/CUMULVS/examples/flyme/Makefile.in
/usr/local/CUMULVS/examples/flyme/README
/usr/local/CUMULVS/examples/flyme/region.c
/usr/local/CUMULVS/examples/flyme/tags
/usr/local/CUMULVS/examples/flyme/util.c
/usr/local/bin/flyme
/usr/local/CUMULVS/examples/slicer/commands.c
/usr/local/CUMULVS/examples/slicer/const.h
/usr/local/CUMULVS/examples/slicer/Makefile
/usr/local/CUMULVS/examples/slicer/Makefile.aimk
/usr/local/CUMULVS/examples/slicer/Makefile.aimk.in
/usr/local/CUMULVS/examples/slicer/Makefile.in
/usr/local/CUMULVS/examples/slicer/README
/usr/local/CUMULVS/examples/slicer/slicer.c
/usr/local/CUMULVS/examples/slicer/slicer_glob.h
/usr/local/CUMULVS/examples/slicer/slicer_glob.c
/usr/local/CUMULVS/examples/slicer/slicer.h
/usr/local/CUMULVS/examples/slicer/slicer.h.in
/usr/local/CUMULVS/examples/slicer/slview.c
/usr/local/CUMULVS/examples/slicer/tags
/usr/local/CUMULVS/examples/slicer/util.c
/usr/local/CUMULVS/examples/slicer/slicer.tcl
/usr/local/CUMULVS/examples/slicer/slicer.tcl.src
/usr/local/CUMULVS/examples/slicer/util.tcl
/usr/local/CUMULVS/examples/slicer/procs.tcl
/usr/local/bin/slicer

/usr/local/bin/cp_region
/usr/local/bin/region

%defattr(-,root,root)


%post
#what to do after the rpm was installed - run stvconfig
/sbin/ldconfig -n /usr/local/lib -v
cd /usr/local/CUMULVS
./stvconfig

%changelog

%preun
# run the sym link cleaner before deinstalling the rpm
cd /usr/local/CUMULVS
./stvuninst

%postun
#what to do after RPM got deinstalled from the system
#in this case just delete the created directory with all files
/bin/rm -rf /usr/local/CUMULVS/makeincl
/bin/rm	-rf  /usr/local/CUMULVS/examples/flyme
/bin/rm -rf  /usr/local/CUMULVS/examples/slicer
/bin/rm -rf /usr/local/CUMULVS/autoconf-macros
/bin/rm -rf /usr/local/CUMULVS

# end of file
